{ Glen's Art Studio R2}
{ February 14, 1998   }
{ Last Update 2/16/98 }
 USES
  CRT,GPal,TPVarCh,DOS;

 CONST
  VidSeg:Word=$A000;

  Black=0;
  Red=40;
  Orange=55;
  Yellow=70;
  Green=85;
  Blue=100;
  Purple=115;
  White=150;
  Fade=300;
  Clear=0;

  MaxGGXWidth=320;
  MaxGGXLength=200;
  MaxPTypes=10;
  MaxWindows=5;
  MaxButtons=4;

 TYPE
  IntFile=File of Integer;
  ByteFile=File of Byte;
  ScreenSize=0..640*480;

  WindowRecord=Record
   X1,X2,XSize                :0..319;
   Y1,Y2,YSize                :0..199;
   XPos                       :-20..339;
   YPos                       :-20..219;
   Opt1,Opt2,Opt3             :0..MaxButtons;
   BodyC,HC,FillC,TextC,TextHC:Byte;
   State,Zoom                 :0..99;
   Title,HTitle               :String;
  End;
  ButtonRecord=Record
   X         :0..319;
   Y         :0..199;
   BAct,BType:0..10;
  End;
  PCXRecord=Record
   Manufacturer  :Byte;
   Version       :Byte;
   Encoding      :Byte;
   BitsPerPixel  :Byte;
   XMin,YMin     :Word;
   XMax,YMax     :Word;
   HRes,VRes     :Word;
   Palette       :Array [0..47] of Byte;
   Reserved      :Byte;
   ColorPlanes   :Byte;
   Bytesperline  :Word;
   PaletteType   :Word;
   Filler        :Array [0..57] of Byte;
  End;

 VAR
  Font                       :Array[32..127,1..10,1..12] of Boolean;
  Window                     :Array[1..MaxWindows] of WindowRecord;
  Button                     :Array[1..MaxButtons] of ButtonRecord;
  PicFile                    :IntFile;
  BFile                      :ByteFile;

  Files                      :Array[0..1023] of string[12];
  FileShl                    :Integer;
  MaxFiles,DirNum,Page,No    :Integer;
  St,FileStart,DirStart,CFile:String;
  DirInfo:SearchRec;

  CurrentFile:Integer;
  FType:String[20];



  PCX               :PCXRecord;
  PCXWidth,PCXLength:Word;
  Bytes             :Word;
  Palette           :Array [0..767] of Byte;
  F                 :File;
  C                 :Byte;
  R                 :0..99;

  VirScr                     :Pointer;
  VirSeg                     :Word;
  GGXScr                     :Pointer;
  GGXSeg                     :Word;
  PCutScr,P1Scr,P2Scr,P3Scr  :Pointer;
  PCutSeg,P1Seg,P2Seg,P3Seg  :Word;

  LastFileName,FileName      :String;
  XChangeStr                 :String;
  XChangeInt                 :Integer;
  XChangeBo                  :Boolean;

  SelectC1,SelectC2,SysRC    :Byte;
  MenuBarC,MenuBarHC         :Byte;
  MenuBarHTextC,MenuBarTextC :Byte;
  BackGroundC                :Byte;
  TextC,BodyBarC             :Byte;
  ButtonHC,ButtonC           :Byte;

  CurrentButtons             :0..MaxButtons;
  CurrentWindows             :0..MaxWindows;
  MovingWindow               :0..MaxWindows;

  ShowPrompt,ShowPCords,ShowTStuff:Boolean;
  x,y,i,i2,i3,i4             :Integer;
  ColorBoardX                :0..319;
  ColorBoardY                :0..199;
  PX,PXO,OffSet,SPX          :0..319;
  PY,PYO,SPY                 :0..199;
  PType,PAct                 :0..MaxPTypes;
  PTypeO,PActO               :0..MaxPTypes;
  LastPType,LastPAct         :0..MaxPTypes;
  FontWidth,FontLength       :Byte;
  GGXWidth                   :1..320;
  GGXLength                  :1..200;
  TSize,MenuOpt,MenuOpt2     :0..19;
  Prompt,OldPrompt           :String;
  PALETTEFILENAME            :String;
  Key,Key2                   :Char;
  Null                       :Boolean;


 Function MouseInstalled:Boolean; Assembler; ASM
  xor ax,ax; int 33h; cmp ax,-1; je @skip; xor al,al; @skip: End;
 Function GetPX:Word; Assembler; ASM
  mov ax,3; int 33h; mov ax,cx End;
 Function GetPY:Word; Assembler; ASM
  mov ax,3; int 33h; mov ax,dx End;
 Function LeftPressed:Boolean; Assembler; ASM
  mov ax,3; int 33h; and bx,1; mov ax,bx End;
 Function RightPressed:Boolean; Assembler; ASM
  mov ax,3; int 33h; and bx,2; mov ax,bx End;

 Procedure SetVGA; Assembler; ASM
  mov ax,13h; int 10h; End;
 Procedure Cls(lvseg:Word); Assembler; ASM
  mov es,[lvseg]; xor di,di; xor ax,ax; mov cx,320*200/2; rep stosw; End;
 Procedure Flip(src,dst,offs:Word); Assembler; ASM
  push ds; mov ds,[src]; mov si,[offs]; mov es,[dst]
  xor di,di; mov cx,320*200/2; rep movsw; pop ds; End;

 Procedure ExitStuff;
 Begin
  FadetoBlack(75);
  ASM mov ax,03h; int 10h; End;
  Writeln('Glen''s Art Studio R2. (c) 1998. Glen H. Barratt Productions.');
  FreeMem(VirScr,320*200);
  FreeMem(P1Scr,20*20);
  FreeMem(P2Scr,20*20);
  FreeMem(P3Scr,20*20);
  FreeMem(PCutScr,20*20);
  Halt;
 End;

 Procedure LoadFont(FontFileName:String);
 Var
  Mi,W,L  :Integer;
  o       :Byte;
 Begin
  Assign(BFile,FontFileName);
   Reset(BFile);
   Read(BFile,FontWidth);
   Read(BFile,FontLength);
   For Mi:= 32 to 127 do begin
    For W:= 0 to FontWidth-1 do For L:= 0 to FontLength-1 do begin
     Font[Mi,W+1,L]:=False;
     Read(BFile,o);
     If o= 1 then Font[Mi,W+1,L]:=True;
    End;
   End;
  Close(BFile);
 End;
 Procedure PlaceText(X,Y:Word;Text:String;C,Place:Word);
 Var Mi,i,i2,W,L:Integer; T:Char;
 Begin
  For Mi:=1 to Length(Text) do begin
   T:=Text[Mi];
   If (T<chr(30))or(T>chr(125)) then T:=chr(32);
   For W:= 0 to FontWidth-1 do
   For L:= 0 to FontLength-1 do begin
    If Font[ord(T),W+1,L]=True then begin
     If (X+W>-1)and(X+W<320)and(Y+L>-1)and(Y+L<200)then begin
      If C>Fade then begin Mem[Place:320*(Y+L)+X+W]:=C-Fade-L; End;
      If C<Fade then Mem[Place:320*(Y+L)+X+W]:=C;
     End;
    End;
   End;
   X:=X+FontWidth;
  End;
 End;
 Procedure PlaceFlameText(X,Y:Word;Text:String;C,S,Place:Word);
 Var R,i,i2,i3:Integer;
 Begin
  For i:=Y+FontLength-1 downto Y-15 do
  For i2:=X to X+(Length(Text)*FontWidth) do begin
   If (Mem[Place:i*320+i2]<>0)and(Mem[Place:(i-1)*320+i2]<>C) then begin
    R:=Random(S);
    If (Mem[Place:i*320+i2]-R-2>=0) then Mem[Place:320*(i-1)+i2]:=Mem[Place:320*i+i2]-R-2;
    If (Mem[Place:i*320+i2]<=C-22) then
     For i3:= i downto Y-16 do Mem[Place:320*(i3)+i2]:=0;
   End;
  End;
 End;

 Procedure RotateColors(Amount:integer);
 Var
  R2,G2,B2,R,G,B:Byte;
  Mi,i:Integer;
 Begin
  If Amount>0 then begin
   For Mi:=1 to Amount do begin
    GetColor(0,R2,G2,B2);
    For i:= 1 to 255 do begin
     GetColor(i,R,G,B);
     MakeColor(i-1,R,G,B);
    End;
    MakeColor(255,R2,G2,B2);
   End;
  End;
  If Amount<0 then begin
   For Mi:=Amount to -1 do begin
    GetColor(255,R2,G2,B2);
    For i:= 254 downto 0 do begin
     GetColor(i,R,G,B);
     MakeColor(i+1,R,G,B);
    End;
    MakeColor(0,R2,G2,B2);
   End;
  End;
 End;



 Procedure PlaceText2(X,Y:Integer;Txt:String;C:Integer;Place:Word);
 Begin
  PlaceText(X,Y+1,Txt,C-8,Place);
  If C=White then  PlaceText(X,Y+1,Txt,C-12,Place);
  PlaceText(X,Y,Txt,C,Place);
 End;

 Procedure Pause; Assembler; ASM xor ax, ax; int 16h; End;


 Procedure ReadPCXLine(OffSet,Place:Word);
 Var
  c,run  :Byte;
  n      :Integer;
  w      :Word;
 Begin
  n:=0;
  While (n<Bytes) do begin
   Blockread (F,C,1);
   If ((c and 192) = 192) then begin
    run:=c and 63;
    blockread (f, c, 1);
    n:=n + run;
    For w:=0 to run - 1 do begin
     Mem[Place:Offset]:=c;
     Inc(Offset);
    End;
   End
   Else begin
    n:=n + 1;
    Mem[Place:Offset]:=c;
    Inc(Offset);
   End;
  End;
 End;
 Procedure LoadPCXPalette;
 Var i:Integer;
 Begin
  For i:=0 to 767 do Palette[i]:=Palette[i] shr 2;
  Asm
   mov ax, 1012h
   xor bx, bx
   mov cx, 256
   mov dx, offset palette
   int 10h
  End;
 End;

 Procedure UnpackPCXFile(Opt:Integer;Place:Word);
 Var i:Integer;
 Begin
  If Opt>0 then LoadPCXPalette;
  For i:=0 to PCXLength-1 do ReadPCXLine(i*320,Place);
 End;
 Procedure PlacePCX(FileName:String;Opt:Integer;Place:Word);
 Begin
  Assign(F,Filename);
   Reset(F,1);
   Blockread(F,PCX,SizeOf(PCX));
   If (PCX.Manufacturer=10) and (PCX.Version=5) and
   (PCX.BitsPerPixel=8) and (PCX.ColorPlanes=1) then begin
    Seek(F,FileSize(F) - 769);
    Blockread(F,C,1);
    If (c=12) then begin
     Blockread(F,palette,768);
     Seek(F,128);
     PCXWidth:=PCX.XMax-PCX.XMin+1;
     PCXLength:=PCX.YMax-PCX.YMin+1;
     GGXWidth:=PCXWidth;
     GGXLength:=PCXLength;
     Bytes:=PCX.BytesPerLine;
     UnpackPCXFile(Opt,Place);
    End
    Else Writeln('Error reading palette.');
   End
   Else Writeln('Not a 256 color PCX File.');
  Close(F);
 End;



 Procedure EnterOption(OptName:String;C:Integer);
 Var
  XCHangeInt2,CLetter,CurAni,CurS,i,i2,i3,Mi,X1,X2,Y1,Y2:Integer;
  Answer:String;
 Begin
  CLetter:=1;
  Answer:='                         ';
  X1:=90;
  X2:=230;
  Y1:=75;
  Y2:=125;
  For i:=X1-1 to X2+1 do
  Mem[VidSeg:320*(Y1-1)+i]:=White-2;
  For i:=X1 to X2 do
  Mem[VidSeg:320*(Y2+1)+i]:=White-13;
  For i2:=Y1 to Y2+1 do
  Mem[VidSeg:320*i2+X1-1]:=White-4;
  For i2:=Y1 to Y2 do
  Mem[VidSeg:320*i2+X2+1]:=White-10;
  For i2:=Y1 to Y2 do
  For i:=X1 to X2 do
  Mem[VidSeg:320*i2+i]:=White-7;
  For i:=X1+10 to X2-10 do
  Mem[VidSeg:320*(Y2-21)+i]:=White-14;
  For i:=X1+10 to X2-10 do
  Mem[VidSeg:320*(Y2-9)+i]:=White-2;
  For i2:=Y2-20 to Y2-10 do
  Mem[VidSeg:320*i2+(X1+9)]:=White-10;
  For i2:=Y2-20 to Y2-10 do
  Mem[VidSeg:320*i2+(X2-9)]:=White-4;
  For i2:=Y2-20 to Y2-10 do
  For i:=X1+10 to X2-10 do
  Mem[VidSeg:320*i2+i]:=Black;
  PlaceText2(Round((X2+X1)/2)-Round(6*(Length(OptName))/2),Y1+10,OptName,C,VidSeg);
  XChangeInt2:=0;
  While Keypressed do begin
   Key:=ReadKey;
  End;
  Repeat
   Delay(1);
   PlaceText(X1+12,Y2-18,Answer,White,VidSeg);
   CurAni:=CurAni+1;
   If CurAni>100 then begin
    CurAni:=0;
    If CurS=1 then CurS:=0 Else CurS:=1;
   End;
   Key:='~';
   For i2:=Y2-19 to Y2-11 do begin
    If CurS=1 then Mem[VidSeg:320*i2+X1+13+6*CLetter-8]:=White;
    If CurS=0 then Mem[VidSeg:320*i2+X1+13+6*CLetter-8]:=Black;
   End;
   Key:='~';
   If Keypressed then Key:=Readkey;
   If Mem[VidSeg:320*(Y2-20)+X1+13+6*CLetter-8]<>Black then Key:=chr(13);
   If (Key<>'~')and(Key<>chr(8))and(Key<>chr(13)) then begin
    For i2:=Y2-19 to Y2-11 do
    Mem[VidSeg:320*i2+X1+13+6*CLetter-8]:=Black;
    Answer[CLetter]:=Key;
    PlaceText(X1+12+6*(CLetter-1),Y2-18,Key,White,VidSeg);
    CLetter:=CLetter+1;
    If (Key>Chr(47))and(Key<chr(58)) then begin
     X:=S2I(Key);
     XChangeInt2:=XChangeInt2*10+X;
    End;
   End;
   If Key=chr(8) then begin
    For i2:=Y2-19 to Y2-11 do
    Mem[VidSeg:320*i2+X1+13+6*CLetter-8]:=Black;
    PlaceText(X1+12+6*(CLetter-2),Y2-18,Answer[CLetter-1],Black,VidSeg);
    Answer[CLetter-1]:=' ';
    CLetter:=CLetter-1;
    If CLetter<1 then CLetter:=1;
    XChangeInt2:=XChangeInt2-X;
    XChangeInt2:=Round(XChangeInt2/10);
   End;
   If Key=chr(13) then begin
    XChangeStr:=Answer;
    XChangeInt:=XChangeInt2;
    If (UpCase(Answer[1])='Y')or(UpCase(Answer[1])='T') then XChangeBo:=True;
    If (UpCase(Answer[1])='N')or(UpCase(Answer[1])='F') then XChangeBo:=False;
   End;
  Until (Key=chr(13))or(Key=chr(27));
  Key:='~';
 End;

 Function EnterBo(OptName:String;C:Integer):Boolean;
 Var
  XCHangeInt2,CLetter,CurAni,CurS,i,i2,i3,Mi,X1,X2,Y1,Y2:Integer;
  Answer:Char;
 Begin
  CLetter:=1;
  X1:=90;
  X2:=230;
  Y1:=85;
  Y2:=115;
  For i:=X1-1 to X2+1 do
  Mem[VidSeg:320*(Y1-1)+i]:=White-2;
  For i:=X1 to X2+1 do
  Mem[VidSeg:320*(Y2+1)+i]:=White-13;
  For i2:=Y1 to Y2+1 do
  Mem[VidSeg:320*i2+X1-1]:=White-4;
  For i2:=Y1 to Y2 do
  Mem[VidSeg:320*i2+X2+1]:=White-10;
  For i2:=Y1 to Y2 do
  For i:=X1 to X2 do
  Mem[VidSeg:320*i2+i]:=White-7;
{  For i:=X1+10 to X2-10 do
  Mem[VidSeg:320*(Y2-21)+i]:=White-14;
  For i:=X1+10 to X2-10 do
  Mem[VidSeg:320*(Y2-9)+i]:=White-2;
  For i2:=Y2-20 to Y2-10 do
  Mem[VidSeg:320*i2+(X1+9)]:=White-10;
  For i2:=Y2-20 to Y2-10 do
  Mem[VidSeg:320*i2+(X2-9)]:=White-4;
  For i2:=Y2-20 to Y2-10 do
  For i:=X1+10 to X2-10 do
  Mem[VidSeg:320*i2+i]:=Black;}
  PlaceText2(Round((X2+X1)/2)-Round(6*(Length(OptName))/2),Y1+10,OptName,C,VidSeg);
  While Keypressed do begin
   Key:=ReadKey;
  End;
  Key:='~';
  Key:=Readkey;
  Answer:=Key;
  If (UpCase(Answer)='Y')or(UpCase(Answer)='T') then XChangeBo:=True;
  If (UpCase(Answer)='N')or(UpCase(Answer)='F') then XChangeBo:=False;
  If Key=chr(13) then XChangeBo:=True;
  EnterBo:=XChangeBo;
  Key:='~';
 End;


 Procedure PlaceDPC(SX,SY,Opt:Integer;FileName:String;Place:Word);
 Var X,Y,PX1,PX2,PY1,PY2,i,i2,i3,i4,O:Integer;
 Begin
  Assign(PicFile,FileName);
  Reset(PicFile);
  Read(PicFile,X);
  Read(PicFile,Y);
  o:= 0;
  If Opt=1 then begin
   PX1:=SX-Round(X/2);
   PY1:=SY-Round(Y/2);
  End;
  If Opt=0 then begin
   PX1:=SX;
   PY1:=SY;
  End;
  PX2:=PX1+X;
  PY2:=PY1+Y;
  If Place=GGXSeg then begin
   GGXLength:=Y+1;
   GGXWidth:=X+1;
  End;
  For i4:= PY1 to PY2 do
  For i2:= PX1 to PX2 do begin
   Read(PicFile,o);
   If (o=0) then o:=0;
   If (o<>0) and (i4>-1)and(i4<200)and(i2>-1)and(i2<320) then begin
    Mem[Place:i2+i4*320]:=o;
   End;
  End;
  Close(PicFile);
 End;


 Procedure ReCropSize;
 Var
  Mi,X,Y,XX,YY,i,i2:Integer;
  o:Byte;
  Passed:Boolean;
 Begin
  Passed:=True;
  EnterOption('New Horiz Width',Red);
  X:=XChangeInt;
  EnterOption('New Vert Length',Red);
  Y:=XChangeInt;
  XX:=((-GGXWidth+X) div 2);
  YY:=((-GGXLength+Y) div 2);

  If (Passed)and(XX>=0)and(YY>=0) then begin
   Passed:=False;
   For i2:= GGXLength-1 downto 0 do
   For i:= GGXWidth-1 downto 0 do begin
    Mem[GGXSeg:320*(i2+YY)+i+XX]:=Mem[GGXSeg:320*i2+i];
   End;
   GGXWidth:=X;
   GGXLength:=Y;
   For i2:= 0 to YY-1 do
   For i:= 0 to GGXWidth-1 do
   Mem[GGXSeg:320*i2+i]:=0;
   For i2:= 0 to GGXLength-1 do
   For i:= 0 to XX-1 do
   Mem[GGXSeg:320*i2+i]:=0;

   For i2:= 0 to YY-1 do
   For i:= 0 to GGXWidth-1 do
   Mem[GGXSeg:320*(i2+GGXLength)+i]:=0;
   For i2:= 0 to GGXLength-1 do
   For i:= 0 to XX-1 do
   Mem[GGXSeg:320*i2+i+GGXWidth]:=0;
  End;

  If (Passed)and(XX>=0)and(YY<=0) then begin
   Passed:=False;
   For i2:= 0 to GGXLength-1 do
   For i:= GGXWidth-1 downto 0 do begin
    Mem[GGXSeg:320*i2+i+XX]:=Mem[GGXSeg:320*(i2-YY)+i];
   End;
   GGXWidth:=X;
   GGXLength:=Y;
   For i2:= 0 to GGXLength-1 do
   For i:= 0 to XX-1 do
   Mem[GGXSeg:320*i2+i]:=0;
   For i2:= 0 to GGXLength-1 do
   For i:= 0 to XX-1 do
   Mem[GGXSeg:320*i2+i+GGXWidth]:=0;
  End;

  If (Passed)and(XX<=0)and(YY>=0) then begin
   Passed:=False;
   For i2:= GGXLength-1 downto 0 do
   For i:= 0 to GGXWidth-1 do begin
    Mem[GGXSeg:320*(i2+YY)+i]:=Mem[GGXSeg:320*i2+i-XX];
   End;
   GGXWidth:=X;
   GGXLength:=Y;
   For i2:= 0 to YY-1 do
   For i:= 0 to GGXWidth-1 do
   Mem[GGXSeg:320*i2+i]:=0;
   For i2:= 0 to YY-1 do
   For i:= 0 to GGXWidth-1 do
   Mem[GGXSeg:320*(i2+GGXLength)+i]:=0;
  End;

  If (Passed)and(XX<=0)and(YY<=0) then begin
   For i2:= 0 to GGXLength-1 do
   For i:= 0 to GGXWidth-1 do begin
    Mem[GGXSeg:320*i2+i]:=Mem[GGXSeg:320*(i2-YY)+i-XX];
   End;
   GGXWidth:=X;
   GGXLength:=Y;
  End;
 End;


 Procedure MirrorImage;
 Var
  Mi,X,Y,i,i2:Integer;
  o:Byte;
 Begin
  For i2:= 0 to GGXLength-1 do
  For i:= 0 to Round(GGXWidth/2)-1 do begin
   o:=Mem[GGXSeg:320*i2+i];
   Mem[GGXSeg:320*i2+i]:=Mem[GGXSeg:320*i2+(GGXWidth-i-1)];
   Mem[GGXSeg:320*i2+(GGXWidth-i-1)]:=o;
  End;
 End;

 Procedure FlipImage;
 Var
  Mi,X,Y,i,i2:Integer;
  o:Byte;
 Begin
  For i2:= 0 to Round(GGXLength/2)-1 do
  For i:= 0 to GGXWidth-1 do begin
   o:=Mem[GGXSeg:320*i2+i];
   Mem[GGXSeg:320*i2+i]:=Mem[GGXSeg:320*(GGXLength-i2-1)+i];
   Mem[GGXSeg:320*(GGXLength-i2-1)+i]:=o;
  End;
 End;

 Procedure InvertImageColors;
 Var
  Mi,X,Y,i,i2:Integer;
  o:Byte;
 Begin
  For i2:= 0 to GGXLength-1 do
  For i:= 0 to GGXWidth-1 do
  Mem[GGXSeg:320*i2+i]:=255-Mem[GGXSeg:320*i2+i];
 End;



 Procedure RotateImage;
 Var
  PX1,PX2,PY1,PY2:Integer;
  Mi,X,Y,X2,Y2,i,i2,i3,i4:Integer;
 Begin

  Assign(PicFile,'UNDO.DAT');
  Reset(PicFile);
  Read(PicFile,X);
  Read(PicFile,Y);
  i:= 0;
  PX1:=0;
  PY1:=0;
  PX2:=PX1+X;
  PY2:=PY1+Y;
  GGXLength:=Y+1;
  GGXWidth:=X+1;
  If GGXLength>200 then GGXLength:=200;
  i:=GGXLength;
  GGXLength:=GGXWidth;
  GGXWidth:=i;
  For i4:= PY1 to PY2 do
  For i2:= PX1 to PX2 do begin
   Read(PicFile,i);
   If (i4>-1)and(i4<200)and(i2>-1)and(i2<200) then begin
    Mem[GGXSeg:320*i2+(GGXWidth-i4-1)]:=i;
   End;
  End;
  Close(PicFile);

  {If X<199 then begin
   i:=Y;
   Y:=X;
   X:=i;
  End
  Else begin
   X:=Y;
  End;}

{  If X>199 then X:=199;

  For i2:= 0 to 99 do
  For i:= 0 to 99 do begin
   BigM[i,i2]:=Mem[GGXSeg:320*i2+i];
  End;

  For i2:= 0 to Y-1 do
  For i:= 0 to X-1 do begin
   Mem[GGXSeg:320*i2+i]:=BigM[i2,i];
  End;}

{  For i2:= 0 to Round(Y/2)-1 do
  For i:= 0 to Round(X/2)-1 do begin

    o1:=Mem[GGXSeg:320*i2+i];
    o2:=Mem[GGXSeg:320*(Y-i2-1)+i];
    o3:=Mem[GGXSeg:320*(Y-i2-1)+(X-i-1)];
    o4:=Mem[GGXSeg:320*i2+(X-i-1)];

    Mem[GGXSeg:320*i2+(X-i-1)]:=o1;
    Mem[GGXSeg:320*(Y-i2-1)+(X-i-1)]:=o4;
    Mem[GGXSeg:320*(Y-i2-1)+i]:=o3;
    Mem[GGXSeg:320*i2+i]:=o2;
  End;}

  {i:=GGXWidth;
  GGXWidth:=GGXLength;
  GGXLength:=i;}

 End;




 Procedure SaveDPC(FileName:String;Place:Word);
 Var X,Y,PX1,PX2,PY1,PY2,i,i2,i3,i4,O:Integer;
 Begin
  Assign(PicFile,FileName);
  ReWrite(PicFile);
  If Place=GGXSeg then begin
   Y:=GGXLength-1;
   X:=GGXWidth-1;
  End
  Else begin
   X:=320;
   Y:=200;
  End;
  Write(PicFile,X);
  Write(PicFile,Y);
  o:= 0;
  For i4:= 0 to Y do
  For i2:= 0 to X do begin
   If (i4>-1)and(i4<200)and(i2>-1)and(i2<320) then begin
    o:=Mem[Place:i2+i4*320];
   End;
   Write(PicFile,o);
  End;
  Close(PicFile);
 End;

 Procedure SaveGGX(FileName:String;Place:Word);
 Var
  X1,X2,Y,PX1,PY1,PY2,i,i2,i3,i4,O:Byte;
  PX2:Integer;
 Begin
  Assign(BFile,FileName);
  ReWrite(BFile);
  If Place=GGXSeg then begin
   Y:=GGXLength;
   If (GGXWidth>70) then begin
    X1:=GGXWidth-70;
    X2:=70;
   End
   Else begin
    X1:=GGXWidth;
    X2:=0;
   End;
  End
  Else begin
   X1:=250;
   X2:=70;
   Y:=200;
  End;
  Write(BFile,X1);
  Write(BFile,X2);
  Write(BFile,Y);
  o:= 0;
  PX1:=0;
  PY1:=0;
  PX2:=PX1+X1+X2;
  PY2:=PY1+Y;
  For i4:= PY1 to PY2 do
  For i2:= PX1 to PX2 do begin
   If (i4>-1)and(i4<200)and(i2>-1)and(i2<320) then begin
    o:=Mem[Place:i2+i4*320];
   End;
   Write(BFile,o);
  End;
  Close(BFile);
 End;


 Procedure LoadPalette(FileName:String);
 Var
  i:Integer;
  R,G,B:Byte;
 Begin
  Assign(BFile,FileName);
  Reset(BFile);
  For i:= 0 to 255 do begin
   R:=63;
   G:=63;
   B:=63;
   Read(BFile,R);
   Read(BFile,G);
   Read(BFile,B);
   MakeColor(i,R,G,B);
  End;
  Close(BFile);
 End;

 Procedure SavePalette(FileName:String);
 Var R,G,B:Byte;
 Begin
  Assign(BFile,FileName);
  ReWrite(BFile);
  For i:= 0 to 255 do begin
   R:=63;
   G:=63;
   B:=63;
   GetColor(i,R,G,B);
   Write(BFile,R);
   Write(BFile,G);
   Write(BFile,B);
  End;
  Close(BFile);
 End;




 Procedure GetPCutSeg(X,Y:Integer;Place:Word);
 Begin
  For i2:= 0 to 19 do
  For i:= 0 to 19 do begin
   Mem[PCutSeg:i+(i2*20)]:=Mem[Place:X+i+(Y+i2)*320];
  End;
 End;
 Procedure PlacePCutSeg(X,Y:Integer;Place:Word);
 Begin
  For i2:= 0 to 19 do
  For i:= 0 to 19 do begin
   If ((Y+i2<200)and(X+i<320)) then
   Mem[Place:X+i+(Y+i2)*320]:=Mem[PCutSeg:i+(i2*20)];
  End;
 End;

 Procedure LoadPSeg(PType:Integer);
 Var
  Mi,X,Y:Integer;
  PX1,PX2,PY1,PY2,i,i2,i3,i4,o:Integer;
  PicFile:File of Integer;
  FileName:String;
 Begin
  For Mi:=1 to MaxPTypes do begin
   If Mi=1 then begin
    Case PType of
     1:FileName:='MOUSE.DPX';
     2:FileName:='MAG.DPX';
     3:FileName:='MARKER.DPX';
     4:FileName:='ROLLER1.DPX';
     5:FileName:='ROLLER2.DPX';
     6:FileName:='TEXT.DPX';
     7:FileName:='DROP.DPX';
     8:FileName:='MOUSE.DPX';
     9:FileName:='MOUSE.DPX';
    10:FileName:='MOUSE.DPX';
    End;
   End;
   If Mi=2 then begin
    Case PType of
     1:FileName:='CLICK.DPX';
     2:FileName:='MAGC.DPX';
     3:FileName:='MARKER.DPX';
     4:FileName:='ROLLER1.DPX';
     5:FileName:='ROLLER2.DPX';
     6:FileName:='TEXT.DPX';
     7:FileName:='DROPC.DPX';
     8:FileName:='MOUSE.DPX';
     9:FileName:='MOUSE.DPX';
    10:FileName:='MOUSE.DPX';
    End;
   End;
   If Mi=3 then begin
    Case PType of
     1:FileName:='CLICK.DPX';
     2:FileName:='MAGB.DPX';
     3:FileName:='MARKER.DPX';
     4:FileName:='ROLLER1.DPX';
     5:FileName:='ROLLER2.DPX';
     6:FileName:='TEXT.DPX';
     7:FileName:='DROPC.DPX';
     8:FileName:='MOUSE.DPX';
     9:FileName:='MOUSE.DPX';
    10:FileName:='MOUSE.DPX';
    End;
   End;
   Assign(PicFile,FileName);
    Reset(PicFile);
    o:= 0;
    PX1:=0;
    PY1:=0;
    Read(PicFile,X);
    PX2:= PX1+X;
    Read(PicFile,Y);
    PY2:= PY1+Y;
    For i4:= PY1 to PY2 do
    For i2:= PX1 to PX2 do begin
     Read(PicFile,o);
     If Mi=1 then Mem[P1Seg:i4*20+i2]:=o;
     If Mi=2 then Mem[P2Seg:i4*20+i2]:=o;
     If Mi=3 then Mem[P3Seg:i4*20+i2]:=o;
    End;
   Close(PicFile);
  End;
 End;
 Procedure PlacePSeg(X,Y,PAct:Integer;Place:Word);
 Begin
  For i2:= 0 to 19 do
  For i:= 0 to 19 do begin
   If ((Y+i2<200)and(Y+i2>-1)and(X+i<320)and(X+i>-1)) then begin
    If PAct=1 then begin
     If (PType>2)and(PType<8) then begin
      If Mem[P1Seg:i2*20+i]<>0 then begin
       If (Mem[P1Seg:i2*20+i]>195)and(Mem[P1Seg:i2*20+i]<211) then
       Mem[Place:X+i+(Y+i2)*320]:=Mem[P1Seg:i2*20+i]-205+SysRC
       Else Mem[Place:X+i+(Y+i2)*320]:=Mem[P1Seg:i2*20+i];
      End;
     End;
     If (PType<3)or(PType>7) then If Mem[P1Seg:i2*20+i]<>0 then Mem[Place:X+i+(Y+i2)*320]:=Mem[P1Seg:i2*20+i];
    End;
   {   If Mem[P1Seg:i2*20+i]<>0 then Mem[Place:X+i+(Y+i2)*320]:=Mem[P1Seg:i2*20+i];

    End;}
    If PAct=2 then begin
     If (PType>2)and(PType<8) then begin
      If Mem[P3Seg:i2*20+i]<>0 then begin
       If (Mem[P3Seg:i2*20+i]>195)and(Mem[P3Seg:i2*20+i]<211) then
       Mem[Place:X+i+(Y+i2)*320]:=Mem[P3Seg:i2*20+i]-205+SelectC1
       Else Mem[Place:X+i+(Y+i2)*320]:=Mem[P3Seg:i2*20+i];
      End;
     End;
     If (PType<3)or(PType>7) then If Mem[P2Seg:i2*20+i]<>0 then Mem[Place:X+i+(Y+i2)*320]:=Mem[P2Seg:i2*20+i];
    End;
    If PAct=3 then begin
     If (PType>2)or(PType<8) then begin
      If Mem[P3Seg:i2*20+i]<>0 then begin
       If (Mem[P3Seg:i2*20+i]>195)and(Mem[P3Seg:i2*20+i]<211) then
       Mem[Place:X+i+(Y+i2)*320]:=Mem[P3Seg:i2*20+i]-205+SelectC2
       Else Mem[Place:X+i+(Y+i2)*320]:=Mem[P3Seg:i2*20+i];
      End;
     End;
     If (PType<3)and(PType>7) then If Mem[P3Seg:i2*20+i]<>0 then Mem[Place:X+i+(Y+i2)*320]:=Mem[P3Seg:i2*20+i];
    End;
   End;
  End;
 End;

 Procedure MouseProcess1;
 Begin
  PlacePSeg(PX,PY,PAct,VirSeg);
 End;
 Procedure MouseProcess2;
 Begin
  PX:=Round(GetPX/2);
  PY:=GetPY;
  PlacePCutSeg(PXO,PYO,VirSeg);
 End;
 Procedure MouseProcess3;
 Begin
  PXO:=PX;
  PYO:=PY;
  GetPCutSeg(PX,PY,VirSeg);
 End;

 Procedure PlaceButton(X,Y,BType,BAct:Integer;Place:Word);
 Var
  i,ButtonHC,ButtonC,i2:Integer;
 Begin
  Y:=Y+4;
  X:=X+4;
  ButtonC:=White-6;
  ButtonHC:=10;
  If BAct=1 then begin
   For i2:=Y-3 to Y+3 do For i:=X-3 to X+3 do Mem[Place:320*i2+i]:=ButtonC-6;
   For i2:=Y-3 to Y+3 do Mem[Place:320*i2+X-4]:=ButtonC-9;
   For i2:=Y-3 to Y+3 do Mem[Place:320*i2+X+4]:=ButtonC-3;
   For i:=X-3 to X+3 do Mem[Place:320*(Y-4)+i]:=ButtonC-3;
   For i:=X-3 to X+3 do Mem[Place:320*(Y+4)+i]:=ButtonC-9;
   Mem[Place:320*(Y+4)+X-4]:=ButtonC-11;
   Mem[Place:320*(Y+4)+X+4]:=ButtonC-6;
   Mem[Place:320*(Y-4)+X-4]:=ButtonC-6;
   Mem[Place:320*(Y-4)+X+4]:=ButtonC-2;
  End;

  If BAct=2 then begin
   For i2:=Y-2 to Y+4 do For i:=X-3 to X+3 do Mem[Place:320*i2+i]:=ButtonC-6;
   For i2:=Y-3 to Y+3 do Mem[Place:320*i2+X+4]:=ButtonC-9;
   For i2:=Y-2 to Y+3 do Mem[Place:320*i2+X-4]:=ButtonC-6;
   For i:=X-4 to X+3 do Mem[Place:320*(Y-3)+i]:=ButtonC-9;
   For i:=X-3 to X+3 do Mem[Place:320*(Y-4)+i]:=ButtonC-11;
   Mem[Place:320*(Y+4)+X+4]:=ButtonC-9;
   Mem[Place:320*(Y+4)+X-4]:=ButtonC-6;
   Mem[Place:320*(Y-4)+X+4]:=ButtonC-11;
   Mem[Place:320*(Y-4)+X-4]:=ButtonC-11;
  End;
  If BAct=2 then Y:=Y+1;
  If BType=1 then begin
   For i2:=-2 to 2 do Mem[Place:320*(Y+i2)+X+i2]:=ButtonHC;
   For i2:=-2 to 2 do Mem[Place:320*(Y+i2)+X-i2]:=ButtonHC;
  End;
  If BType=2 then begin
   For i2:=Y-2 to Y+2 do Mem[Place:320*i2+X-2]:=ButtonHC;
   For i2:=Y-2 to Y+2 do Mem[Place:320*i2+X+2]:=ButtonHC;
   For i:=X-2 to X+2 do Mem[Place:320*(Y-2)+i]:=ButtonHC;
   For i:=X-2 to X+2 do Mem[Place:320*(Y+2)+i]:=ButtonHC;
  End;
  If BType=3 then begin
   For i2:=Y-1 to Y+1 do Mem[Place:320*i2+X-1]:=ButtonHC;
   For i2:=Y-1 to Y+1 do Mem[Place:320*i2+X+1]:=ButtonHC;
   For i:=X-1 to X+1 do Mem[Place:320*(Y-1)+i]:=ButtonHC;
   For i:=X-1 to X+1 do Mem[Place:320*(Y+1)+i]:=ButtonHC;
  End;
  If BType=4 then begin
   PlaceText(X-1,Y-3,'?',ButtonHC,Place);
  End;
  If BType=5 then begin
   For i2:=Y-2 to Y+2 do Mem[Place:320*i2+X-1]:=ButtonHC;
   For i2:=Y-1 to Y+1 do Mem[Place:320*i2+X]:=ButtonHC;
   Mem[Place:320*Y+X+1]:=ButtonHC;
  End;
  If BType=6 then begin
   For i2:=Y-2 to Y+2 do Mem[Place:320*i2+X+1]:=ButtonHC;
   For i2:=Y-1 to Y+1 do Mem[Place:320*i2+X]:=ButtonHC;
   Mem[Place:320*Y+X-1]:=ButtonHC;
  End;
  If BType=7 then begin
   For i:=X-2 to X+2 do Mem[Place:320*(Y-1)+i]:=ButtonHC;
   For i:=X-1 to X+1 do Mem[Place:320*(Y)+i]:=ButtonHC;
   Mem[Place:320*(Y+1)+X]:=ButtonHC;
  End;
  If BType=8 then begin
   For i:=Y-2 to Y+2 do Mem[Place:320*(Y+1)+i]:=ButtonHC;
   For i:=Y-1 to Y+1 do Mem[Place:320*(Y)+i]:=ButtonHC;
   Mem[Place:320*(Y-1)+X]:=ButtonHC;
  End;
 End;


 Procedure PlaceMainStuff(Place:Word);
 Begin
  For i2:=1 to 14 do For i:=1 to 318 do Mem[Place:i2*320+i]:=MenubarHC;
  For i:=0 to 319 do Mem[Place:i]:=MenuBarC-1;
  For i2:=14 to 25 do For i:=1 to 318 do Mem[Place:i2*320+i]:=MenubarC-6;
  For i2:=1 to 25 do Mem[Place:i2*320]:=MenuBarC-9;
  For i2:=1 to 25 do Mem[Place:i2*320+319]:=MenuBarC-3;
  For i:=0 to 319 do Mem[Place:i+320*25]:=MenuBarC-10;
  Mem[Place:320*0+0]:=MenuBarC-6;
  Mem[Place:320*25+0]:=MenuBarC-11;
  Mem[Place:320*25+319]:=MenuBarC-6;

  If MenuBarC=MenuBarHC+3 then For i:=0 to 319 do Mem[Place:i+320*14]:=MenuBarC-10;

  For i2:=26 to 199 do For i:=0 to 319 do Mem[Place:i2*320+i]:=BackGroundC;
  PlaceDPC(65,7,1,'GAS2.DPX',Place);
  PlaceDPC(7,7,1,'PI4.DPX',Place);
  PlaceText(111,3,'R2',Fade+White,Place);

  PlaceText2(4,15,' File  Edit  Tools  Filters  Palette  Options  Help',MenuBarTextC,Place);
 End;


 Procedure PlaceBoard(X1,Y1,X2,Y2,Opt1,Opt2,Opt3:Integer;BodyC,FillC:Byte;Place:Word);
 Var HCLength,Height:1..50;
 Begin
  Height:=1;

  For i2:=Y1+Height to Y2-Height do For i:=X1+Height to X2-Height do Mem[Place:i2*320+i]:=BodyC-6;
  For i:=X1 to X2 do Mem[Place:i+320*Y1]:=BodyC-1;
  For i:=X1 to X2 do Mem[Place:i+320*Y2]:=BodyC-10;
  For i2:=Y1+Height to Y2-Height do Mem[Place:i2*320+X1]:=BodyC-9;
  For i2:=Y1+Height to Y2-Height do Mem[Place:i2*320+X2]:=BodyC-3;
  Mem[Place:320*Y1+X1]:=BodyC-6;
  Mem[Place:320*Y2+X1]:=BodyC-10;
  Mem[Place:320*Y2+X2]:=BodyC-6;
  If Opt1=1 then begin
   For i2:=Y1+Height+2 to Y2-Height-2 do Mem[Place:i2*320+X1+2]:=BodyC-3;
   For i2:=Y1+Height+1 to Y2-Height-2 do Mem[Place:i2*320+X2-2]:=BodyC-9;
   For i:=X1+3 to X2-2 do Mem[Place:i+320*(Y1+2)]:=BodyC-10;
   For i:=X1+2 to X2-3 do Mem[Place:i+320*(Y2-2)]:=BodyC-1;
  End;

  If Opt2=1 then begin
   If CurrentButtons<Opt3 then CurrentButtons:=Opt3;
   Button[Opt3].X:=X2-10;
   Button[Opt3].Y:=Y1+2;
   Button[Opt3].BType:=1;
   Button[Opt3].BAct:=1;
   PlaceButton(Button[Opt3].X,Button[Opt3].Y,Button[Opt3].BType,Button[Opt3].BAct,Place);
  End;

  If FillC<>BodyC then
  For i2:=Y1+Height+2 to Y2-Height-2 do For i:=X1+Height+2 to X2-Height-2 do Mem[Place:i2*320+i]:=FillC;

 End;




 Procedure PlaceWindow(Num:Integer;Place:Word);
 Var
  HCLength,Height:1..50;
  i,i2,Zoom,X1,Y1,X2,Y2,Opt1,Opt2,Opt3:Integer;
  Text,HText:String;
  BodyC,HC,FillC,TextC,TextHC:Byte;
 Begin
  HCLength:=11;
  Height:=1;

  Opt1:=Window[Num].Opt1;
  Opt2:=Window[Num].Opt2;
  Opt3:=Window[Num].Opt3;
  Zoom:=Window[Num].Zoom;
  X1:=Window[Num].X1;
  Y1:=Window[Num].Y1;
  If (Opt1=2) then begin
   If (X1+GGXWidth*Zoom+3<320) then Window[Num].X2:=X1+GGXWidth*Zoom+5
   Else Window[Num].X2:=319;
   If (Y1+GGXLength*Zoom+5+HCLength<ColorboardY) then
   Window[Num].Y2:=Y1+GGXLength*Zoom+5+HCLength
   Else Window[Num].Y2:=ColorboardY-1;
  End;
  X2:=Window[Num].X2;
  Y2:=Window[Num].Y2;
  BodyC:=Window[Num].BodyC;
  HC:=Window[Num].HC;
  FillC:=Window[Num].FillC;
  TextC:=Window[Num].TextC;
  TextHC:=Window[Num].TextHC;
  Text:=Window[Num].Title;
  HText:=Window[Num].HTitle;
  If Y2>ColorBoardY-1 then Y2:=ColorBoardY-1;
  If X2>319 then X2:=319;

  For i2:=Y1+Height to Y2-Height do For i:=X1+Height to X2-Height do Mem[Place:i2*320+i]:=HC;
  For i2:=Y1+Height+HCLength to Y2-Height do For i:=X1+Height to X2-Height do Mem[Place:i2*320+i]:=BodyC-6;
  For i:=X1 to X2 do Mem[Place:i+320*Y1]:=BodyC-1;
  For i:=X1 to X2 do Mem[Place:i+320*Y2]:=BodyC-10;
  For i2:=Y1+Height to Y2-Height do Mem[Place:i2*320+X1]:=BodyC-9;
  For i2:=Y1+Height to Y2-Height do Mem[Place:i2*320+X2]:=BodyC-3;
  If BodyC=HC+3 then For i:=X1 to X2 do Mem[Place:i+320*(Y1+HCLength+1)]:=BodyC-10;
  PlaceText(X1+3,Y1+2,Text,TextC,Place);
  PlaceText(X1+3,Y1+2,HText,TextHC,Place);
  If (Opt1>0) then begin
   For i2:=Y1+Height+HCLength+2 to Y2-Height-2 do Mem[Place:i2*320+X1+2]:=BodyC-3;
   For i2:=Y1+Height+HCLength+1 to Y2-Height-2 do Mem[Place:i2*320+X2-2]:=BodyC-9;
   For i:=X1+3 to X2-2 do Mem[Place:i+320*(Y1+HCLength+2)]:=BodyC-10;
   For i:=X1+2 to X2-3 do Mem[Place:i+320*(Y2-2)]:=BodyC-1;
  End;
  If FillC<>BodyC then
  For i2:=Y1+Height+HCLength+2 to Y2-Height-2 do For i:=X1+Height+2 to X2-Height-2 do Mem[Place:i2*320+i]:=FillC;

  If Opt1=2 then begin
   For i2:=0 to GGXLength-1 do
   For i:=0 to GGXWidth-1 do begin
    For i3:=0 to Zoom-1 do
    For i4:=0 to Zoom-1 do begin

     If (((Y1+Height+HCLength+2+i3)+i2*Zoom<ColorBoardY-3)and((X1+Height+2+i4)+i*Zoom<317))
     and ((i+Window[Num].XPos<GGXWidth)and(i2+Window[Num].YPos<GGXLength)) then
     Mem[Place:320*((Y1+Height+HCLength+2+i3)+i2*Zoom)+((X1+Height+2+i4)+i*Zoom)]:=
     Mem[GGXSeg:(i2+Window[Num].YPos)*320+(i+Window[Num].XPos)];

    End;
   End;
  End;

  If Opt2=1 then begin
   If CurrentButtons<Opt3 then CurrentButtons:=Opt3;
   Button[Opt3].X:=X2-10;
   Button[Opt3].Y:=Y1+2;
   Button[Opt3].BAct:=1;
   Button[Opt3].BType:=1;
   PlaceButton(Button[Opt3].X,Button[Opt3].Y,Button[Opt3].BType,Button[Opt3].BAct,Place);
  End;
 End;


 Procedure RefreshSelectedColors(Place:Word);
 Var X,Y:Integer;
 Begin
  X:=ColorBoardX;
  Y:=ColorBoardY;
  For i2:= Y+4 to Y+10 do For i:= 0 to 51 do
  Mem[Place:320*i2+X+4+i]:=SelectC1;
  For i2:= Y+13 to Y+19 do For i:= 0 to 51 do
  Mem[Place:320*i2+X+4+i]:=SelectC2;
 End;

 Procedure PlaceColorBoard(Place:Word);
 Var X,Y:Integer;
 Begin
  X:=ColorBoardX;
  Y:=ColorBoardY;
  PlaceBoard(X,Y,X+319,Y+23,0,0,0,BodyBarC,BodyBarC,VirSeg);
  For i2:= Y+4 to Y+19 do For i:= 0 to 255 do
  Mem[Place:320*i2+X+59+i]:=i;
  RefreshSelectedColors(Place);
 End;

 Procedure PlacePCords(Place:Word);
 Var X,Y:Integer;
 Begin
  X:=ColorBoardX;
  Y:=ColorBoardY;
  PlaceBoard(X+251,Y+24,X+319,199,0,0,0,BodyBarC,BodyBarC,VirSeg);
 End;

 Procedure PlaceTStuff(Place:Word);
 Var X,Y,Size:Integer;
 Begin
  X:=ColorBoardX;
  Y:=ColorBoardY;
  PlaceBoard(X,Y+24,X+59,199,0,0,0,BodyBarC,BodyBarC,VirSeg);
  If PType=2 then begin
   PlaceText(X+27,((Y+29+199) div 2)-FontLength+2,I2S(Window[1].Zoom),211+Window[1].Zoom*3,Place);
  End;
  If PType=3 then begin
   Size:=TSize;
   If Size>10 then Size:=10;
   For i2:= Y+30 to Y+30+Size-1 do For i:= X+6 to X+6+Size-1 do
   Mem[Place:320*(i2-(Size div 2))+X+i-(Size div 2)]:=SysRC;
   PlaceText(X+57-Length(I2S(TSize))*FontWidth,((Y+29+199) div 2)-FontLength+2,I2S(TSize),211+TSize,Place);
  End;
  If PType=4 then begin
   Size:=TSize;
   If Size>10 then Size:=10;
   For i2:= Y+25 to Y+25+Size-1 do For i:= X+1 to X+1 do
   Mem[Place:320*i2+X+i]:=SysRC;
   PlaceText(X+57-Length(I2S(TSize))*FontWidth,((Y+29+199) div 2)-FontLength+2,I2S(TSize),211+TSize,Place);
  End;
  If PType=5 then begin
   Size:=TSize;
   If Size>58 then Size:=58;
   For i2:= Y+25 to Y+25 do For i:= X+1 to X+1+Size-1 do
   Mem[Place:320*i2+X+i]:=SysRC;
   PlaceText(X+57-Length(I2S(TSize))*FontWidth,((Y+29+199) div 2)-FontLength+2,I2S(TSize),211+TSize,Place);
  End;
 End;

 Procedure PlacePrompt(Place:Word);
 Var i,i2,X,Y,Size:Integer;
 Begin
  X:=ColorBoardX;
  Y:=ColorBoardY;
  For i2:=Y+24 to 199 do
  For i:=X+60 to X+X+70+FontWidth*Length(OldPrompt) do
  Mem[Place:320*i2+i]:=BackGroundC;
  PlaceBoard(X+60,Y+24,X+X+70+FontWidth*Length(Prompt),199,0,0,0,BodyBarC,BodyBarC,VirSeg);
  PlaceText(X+65,((Y+29+199) div 2)-FontLength+2,Prompt,TextC,Place);
  OldPrompt:=Prompt;
 End;

 Procedure RefreshPCords(Place:Word);
 Begin
  X:=ColorBoardX;
  Y:=ColorBoardY;
  PlaceText(X+259,((Y+29+199) div 2)-FontLength+2,I2S(PXO),BodyBarC-6,Place);
  PlaceText(X+294,((Y+29+199) div 2)-FontLength+2,I2S(PYO),BodyBarC-6,Place);
  PlaceText(X+259,((Y+29+199) div 2)-FontLength+2,I2S(PX),211+PX div 11,Place);
  PlaceText(X+294,((Y+29+199) div 2)-FontLength+2,I2S(PY),Round(211+PY/6.75),Place);
 End;

 Procedure PlaceWindows(Place:Word);
 Begin
  For i:=1 to CurrentWindows do PlaceWindow(i,Place);
 End;

 Procedure PlaceMenuOpt(TextHC:Integer;Place:Word);
 Var vLength:Integer;
 Begin
  {PlaceText2(4,15,' File  Edit  Tools  Filters  Palette  Options  Help',TextHC,Place);}
   {MenuOpt:=7;
   MenuOpt2:=1;}
   Case MenuOpt of
    1:X:=0;
    2:X:=36;
    3:X:=74;
    4:X:=116;
    5:X:=170;
    6:X:=223;
    7:X:=240;
   End;
   Case MenuOpt of
    1:vLength:=87;
    2:vLength:=85;
    3:vLength:=115;
    4:vLength:=85;
    5:vLength:=45;
    6:vLength:=45;
    7:vLength:=35;
   End;

   PlaceBoard(X+0,26,X+79,26+vLength,0,0,0,BodyBarC,BodyBarC,Place);
   If MenuOpt=7 then X:=X+28;
   For i:=X+1 to X+49 do Mem[Place:320*25+i]:=BodyBarC-6;
   For i:=X+1 to X+49 do Mem[Place:320*26+i]:=BodyBarC-6;
   If MenuOpt<>7 then begin
    For i:=X+50 to X+79 do Mem[Place:320*26+i]:=BodyBarC-1;
    For i:=25 to 26 do Mem[Place:320*i+X]:=BodyBarC-9;
  End;

  If MenuOpt=1 then begin
   MenuOpt2:=0;
   If (PX>0)and(PX<80)then begin
    If (PY>29)and(PY<40)then MenuOpt2:=1;
    If (PY>39)and(PY<50)then MenuOpt2:=2;
    If (PY>49)and(PY<60)then MenuOpt2:=3;
    If (PY>59)and(PY<70)then MenuOpt2:=4;
    If (PY>69)and(PY<80)then MenuOpt2:=5;
    If (PY>79)and(PY<90)then MenuOpt2:=6;
    If (PY>89)and(PY<100)then MenuOpt2:=7;
    If (PY>101)and(PY<111)then MenuOpt2:=8;
   End;
   Case MenuOpt2 of
    1:For i2:=30 to 39 do For i:=1 to 13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    2:For i2:=40 to 49 do For i:=1 to 13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    3:For i2:=50 to 59 do For i:=1 to 13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    4:For i2:=60 to 69 do For i:=1 to 13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    5:For i2:=70 to 79 do For i:=1 to 13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    6:For i2:=80 to 89 do For i:=1 to 13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    7:For i2:=90 to 99 do For i:=1 to 13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    8:For i2:=102 to 111 do For i:=1 to 13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
   End;
   PlaceText2(4,15,' File ',TextHC,Place);
   PlaceText2(5,30,'New File  F1',MenuBarTextC,Place);
   PlaceText2(5,40,'Load File F2',MenuBarTextC,Place);
   PlaceText2(5,50,'Save As   F3',MenuBarTextC,Place);
   PlaceText2(5,60,'Save      F4',MenuBarTextC,Place);
   PlaceText2(5,70,'Print     F9',MenuBarTextC,Place);
   PlaceText2(5,80,'Settings F10',MenuBarTextC,Place);
   PlaceText2(5,90,'Exit     Esc',MenuBarTextC,Place);
   i2:=11;
   If (Length(LastFileName)<i2) then i2:=Length(LastFileName);
   For i:=Length(LastFileName)-i2 to Length(LastFileName) do
   PlaceText(5+(i-(Length(LastFileName)-i2))*FontWidth,103,LastFileName[i],MenuBarTextC,Place);
   For i:=X+3 to X+76 do Mem[Place:320*101+i]:=BodyBarC-9;
  End;

  If MenuOpt=2 then begin
   MenuOpt2:=0;
   If (PX>35)and(PX<116)then begin
    If (PY>29)and(PY<40)then MenuOpt2:=1;
    If (PY>39)and(PY<50)then MenuOpt2:=2;
    If (PY>49)and(PY<60)then MenuOpt2:=3;
    If (PY>59)and(PY<70)then MenuOpt2:=4;
    If (PY>69)and(PY<80)then MenuOpt2:=5;
    If (PY>79)and(PY<90)then MenuOpt2:=6;
    If (PY>89)and(PY<100)then MenuOpt2:=7;
    If (PY>99)and(PY<110)then MenuOpt2:=8;
   End;
   Case MenuOpt2 of
    1:For i2:=30 to 39 do For i:=37 to 36+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    2:For i2:=40 to 49 do For i:=37 to 36+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    3:For i2:=50 to 59 do For i:=37 to 36+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    4:For i2:=60 to 69 do For i:=37 to 36+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    5:For i2:=70 to 79 do For i:=37 to 36+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    6:For i2:=80 to 89 do For i:=37 to 36+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    7:For i2:=90 to 99 do For i:=37 to 36+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    8:For i2:=100 to 109 do For i:=37 to 36+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
   End;
   PlaceText2(40,15,' Edit ',TextHC,Place);
   PlaceText2(34,30,' Undo       Z',MenuBarTextC,Place);
   PlaceText2(34,40,' Size       A',MenuBarTextC,Place);
   PlaceText2(34,50,' Copy       C',MenuBarTextC,Place);
   PlaceText2(34,60,' Cut        X',MenuBarTextC,Place);
   PlaceText2(34,70,' Paste      V',MenuBarTextC,Place);
   PlaceText2(34,80,' Flip       F',MenuBarTextC,Place);
   PlaceText2(34,90,' Mirror     D',MenuBarTextC,Place);
  PlaceText2(34,100,' Rotate     S',MenuBarTextC,Place);
  End;

  If MenuOpt=3 then begin
   MenuOpt2:=0;
   If (PX>74)and(PX<154)then begin
    If (PY>29)and(PY<40)then MenuOpt2:=1;
    If (PY>39)and(PY<50)then MenuOpt2:=2;
    If (PY>49)and(PY<60)then MenuOpt2:=3;
    If (PY>59)and(PY<70)then MenuOpt2:=4;
    If (PY>69)and(PY<80)then MenuOpt2:=5;
    If (PY>79)and(PY<90)then MenuOpt2:=6;
    If (PY>89)and(PY<100)then MenuOpt2:=7;
    If (PY>99)and(PY<110)then MenuOpt2:=8;
    If (PY>109)and(PY<120)then MenuOpt2:=9;
    If (PY>119)and(PY<130)then MenuOpt2:=10;
    If (PY>129)and(PY<140)then MenuOpt2:=11;
   End;
   Case MenuOpt2 of
    1:For i2:=30 to 39 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    2:For i2:=40 to 49 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    3:For i2:=50 to 59 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    4:For i2:=60 to 69 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    5:For i2:=70 to 79 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    6:For i2:=80 to 89 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    7:For i2:=90 to 99 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    8:For i2:=100 to 109 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    9:For i2:=110 to 119 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    10:For i2:=120 to 129 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    11:For i2:=130 to 139 do For i:=75 to 74+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
   End;
   PlaceText2(76,15,' Tools',TextHC,Place);
   PlaceText2(72,30,' Pointer    1',MenuBarTextC,Place);
   PlaceText2(72,40,' Zoom       2',MenuBarTextC,Place);
   PlaceText2(72,50,' Marker     3',MenuBarTextC,Place);
   PlaceText2(72,60,' H Roller   4',MenuBarTextC,Place);
   PlaceText2(72,70,' V Roller   5',MenuBarTextC,Place);
   PlaceText2(72,80,' Text       6',MenuBarTextC,Place);
   PlaceText2(72,90,' Droper     7',MenuBarTextC,Place);
  PlaceText2(72,100,' Shape      8',MenuBarTextC,Place);
  PlaceText2(72,110,' Selecter   9',MenuBarTextC,Place);
  PlaceText2(72,120,' FX/Fill    0',MenuBarTextC,Place);
  PlaceText2(72,130,' Pal Editor P',MenuBarTextC,Place);
  End;

  If MenuOpt=4 then begin
   MenuOpt2:=0;
   If (PX>116)and(PX<196)then begin
    If (PY>29)and(PY<40)then MenuOpt2:=1;
    If (PY>39)and(PY<50)then MenuOpt2:=2;
    If (PY>49)and(PY<60)then MenuOpt2:=3;
    If (PY>59)and(PY<70)then MenuOpt2:=4;
    If (PY>69)and(PY<80)then MenuOpt2:=5;
    If (PY>79)and(PY<90)then MenuOpt2:=6;
    If (PY>89)and(PY<100)then MenuOpt2:=7;
    If (PY>99)and(PY<110)then MenuOpt2:=8;
   End;
   Case MenuOpt2 of
    1:For i2:=30 to 39 do For i:=117 to 116+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    2:For i2:=40 to 49 do For i:=117 to 116+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    3:For i2:=50 to 59 do For i:=117 to 116+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    4:For i2:=60 to 69 do For i:=117 to 116+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    5:For i2:=70 to 79 do For i:=117 to 116+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    6:For i2:=80 to 89 do For i:=117 to 116+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    7:For i2:=90 to 99 do For i:=117 to 116+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    8:For i2:=100 to 109 do For i:=117 to 116+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
   End;
   PlaceText2(118,15,' Filters',TextHC,Place);
   PlaceText2(114,30,' Invert     I',MenuBarTextC,Place);
   PlaceText2(114,40,' TransColor T',MenuBarTextC,Place);
   PlaceText2(114,50,' MagicColor G',MenuBarTextC,Place);
   PlaceText2(114,60,' FreakColor H',MenuBarTextC,Place);
   PlaceText2(114,70,' ColorMatch J',MenuBarTextC,Place);
   PlaceText2(114,80,' MeltImage  M',MenuBarTextC,Place);
   PlaceText2(114,90,' Smudge     <',MenuBarTextC,Place);
  PlaceText2(114,100,' Explosion  >   ',MenuBarTextC,Place);
  End;

  If MenuOpt=5 then begin
   MenuOpt2:=0;
   If (PX>170)and(PX<249)then begin
    If (PY>29)and(PY<40)then MenuOpt2:=1;
    If (PY>39)and(PY<50)then MenuOpt2:=2;
    If (PY>49)and(PY<60)then MenuOpt2:=3;
    If (PY>59)and(PY<70)then MenuOpt2:=4;
   End;
   Case MenuOpt2 of
    1:For i2:=30 to 39 do For i:=171 to 170+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    2:For i2:=40 to 49 do For i:=171 to 170+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    3:For i2:=50 to 59 do For i:=171 to 170+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    4:For i2:=60 to 69 do For i:=171 to 170+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
   End;
   PlaceText2(172,15,' Palette',TextHC,Place);
   PlaceText2(169,30,' Pal Editor P',MenuBarTextC,Place);
   PlaceText2(169,40,' Load Pal   [',MenuBarTextC,Place);
   PlaceText2(169,50,' Save Pal   ]',MenuBarTextC,Place);
   PlaceText2(169,60,' Rotate Pal \',MenuBarTextC,Place);
  End;

  If MenuOpt=6 then begin
   MenuOpt2:=0;
   If (PX>223)and(PX<303)then begin
    If (PY>29)and(PY<40)then MenuOpt2:=1;
    If (PY>39)and(PY<50)then MenuOpt2:=2;
    If (PY>49)and(PY<60)then MenuOpt2:=3;
    If (PY>59)and(PY<70)then MenuOpt2:=4;
   End;
   Case MenuOpt2 of
    1:For i2:=30 to 39 do For i:=224 to 223+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    2:For i2:=40 to 49 do For i:=224 to 223+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    3:For i2:=50 to 59 do For i:=224 to 223+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    4:For i2:=60 to 69 do For i:=224 to 223+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
   End;
   PlaceText2(226,15,' Options    ',TextHC,Place);
   PlaceText2(222,30,' Sys Colors ''',MenuBarTextC,Place);
   PlaceText2(222,40,' Start File :',MenuBarTextC,Place);
   PlaceText2(222,50,' Controls   L',MenuBarTextC,Place);
   PlaceText2(222,60,' Other Opts K',MenuBarTextC,Place);
  End;

  If MenuOpt=7 then begin
   MenuOpt2:=0;
   If (PX>240)and(PX<320)then begin
    If (PY>29)and(PY<40)then MenuOpt2:=1;
    If (PY>39)and(PY<50)then MenuOpt2:=2;
    If (PY>49)and(PY<60)then MenuOpt2:=3;
   End;
   Case MenuOpt2 of
    1:For i2:=30 to 39 do For i:=241 to 240+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    2:For i2:=40 to 49 do For i:=241 to 240+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
    3:For i2:=50 to 59 do For i:=241 to 240+13*FontWidth do Mem[Place:320*i2+i]:=TextHC;
   End;
   PlaceText2(280,15,' Help',TextHC,Place);
   PlaceText2(238,30,' Index      ?',MenuBarTextC,Place);
   PlaceText2(238,40,' Keys       K',MenuBarTextC,Place);
   PlaceText2(238,50,' About GArt Q',MenuBarTextC,Place);
  End;

  If (PAct>1) then begin
   If (MenuOpt=1) then begin
    If MenuOpt2=1 then begin
     Null:=True;
     Key2:=Chr(59);
    End;
    If MenuOpt2=2 then begin
     Null:=True;
     Key2:=Chr(60);
    End;
    If MenuOpt2=3 then begin
     Null:=True;
     Key2:=Chr(61);
    End;
    If MenuOpt2=4 then begin
     Null:=True;
     Key2:=Chr(61);
    End;
    If MenuOpt2=7 then begin
     Null:=False;
     Key:=Chr(27);
    End;

    MenuOpt:=0;
    MenuOpt2:=0;
   End;

   If (MenuOpt=2) then begin
    If MenuOpt2=6 then begin
     SaveDPC('UNDO.DAT',GGXSeg);
     FlipImage;
     PlaceWindow(1,VirSeg);
    End;
    If MenuOpt2=7 then begin
     SaveDPC('UNDO.DAT',GGXSeg);
     MirrorImage;
     PlaceWindow(1,VirSeg);
    End;
    If MenuOpt2=8 then begin
     SaveDPC('UNDO.DAT',GGXSeg);
     RotateImage;
     PlaceMainStuff(VirSeg);
     PlaceWindows(VirSeg);
     PlaceColorBoard(VirSeg);
     If ShowPCords then PlacePCords(VirSeg);
     If ShowTStuff then PlaceTStuff(VirSeg);
     If ShowPrompt then PlacePrompt(VirSeg);
    End;
    MenuOpt:=0;
    MenuOpt2:=0;
   End;

   If (MenuOpt=3) then begin
    LastPType:=PType;
    Case MenuOpt2 of
     1:PType:=1;
     2:PType:=2;
     3:PType:=3;
     4:PType:=4;
     5:PType:=5;
     6:PType:=6;
     7:PType:=7;
     8:PType:=8;
     9:PType:=9;
{    10:;
    11:;}
    End;
    LoadPSeg(PType);
    MenuOpt2:=0;
   End;
   If MenuOpt=5 then begin
    Case MenuOpt2 of
     1:Key:='P';
     2:Key:='[';
     3:Key:=']';
     4:Key:='\';
    End;
    MenuOpt:=0;
    MenuOpt2:=0;
   End;

   If (MenuOpt2=0) then begin
    MenuOpt:=0;
    PlaceMainStuff(VirSeg);
    PlaceWindows(VirSeg);
    PlaceColorBoard(VirSeg);
    If ShowPCords then PlacePCords(VirSeg);
    If ShowTStuff then PlaceTStuff(VirSeg);
    If ShowPrompt then PlacePrompt(VirSeg);
   End;
  End;

  {PlaceText2(4,15,' File  Edit  Tools  Filters  Palette  Options  Help',TextHC,Place);}
 End;


 Procedure SortFiles(l,r:Integer);
 Var
  i,j:integer;
  m,t:string[12];
 Begin
  i:=l; j:=r; m:=Files[(L+R) shr 1];
  Repeat
   While Files[i]<m do Inc(i);  { Move right }
   While m<Files[j] do Dec(j);  { Move left }
   If i<=j then begin
    t:=Files[i]; Files[i]:=Files[j]; Files[j]:=t;
    Inc(i); Dec(j);
   End;
  Until i>j;
  If l<j then SortFiles(l,j);
  If i<r then SortFiles(i,r);
 End;

 Procedure GetFiles(Path:String);
 Var
  DirInfo:SearchRec;
 Begin
  MaxFiles:=0;
  DirNum:=0;
  Page:=0;
  No:=0;

  FindFirst(DirStart+'*.*',AnyFile,DirInfo);
  While DosError=0 do begin
   If DirInfo.Attr in [$10..$17] then
   If ((DirInfo.Name<>'s..ds')or(Length(DirStart)>3)) then begin
    If DirInfo.Name[1]<>'.' then Files[DirNum]:='<'+DirInfo.Name+'>'
    Else Files[DirNum]:=DirInfo.Name;
    Inc(DirNum);
   End;
   FindNext(DirInfo);
  End;

  MaxFiles:=DirNum;
  FindFirst(Path,AnyFile,DirInfo);

  While DosError=0 do begin
   If DirInfo.Attr in [$00..$07,$20..$27] then begin
    Files[MaxFiles]:=DirInfo.Name;
    Inc(MaxFiles);
   End;
   FindNext(DirInfo);
  End;

  SortFiles(0,DirNum-1);
  SortFiles(DirNum,MaxFiles-1);
 End;

 Function TestDir(Path:String;DirType:Byte):integer;
 Var DirInfo:SearchRec;    { DirType: 1=File, 2=Dir, 3=Vol }
 Begin                     { 0=Find not, 1=Yes }
  FindFirst(Path,AnyFile,DirInfo); TestDir:=0;
  While DosError=0 do begin
   Case DirType of
    1:If DirInfo.Attr in [$00..$07,$20..$27] then begin TestDir:=1; Exit; End;
    2:If DirInfo.Attr in [$10..$17] then begin TestDir:=1; Exit; End;
    3:If DirInfo.Attr in [$08,$18,$28] then begin TestDir:=1; Exit; End;
   End;
   FindNext(DirInfo);
  End;
 End;

 Procedure PlaceFiles(Path:String;Color:Byte;Place:Word);
 Var
  X,Y,i,i2:Integer;
 Begin
  i2:=0;
{ For i:=1 to Length(Path) do if Path[i] in ['!','#'] then i2:=1;}
  If (i2=0) and (TestDir(Path,2)=1) then begin
   GetFiles(Path);
  End Else Begin
   PlaceText(10,10,'ERROR BAD DIRECTORY OR FILE MASK',Red,VidSeg);
   Sound(2000);
   Delay(200);
   NoSound;
  End;
  For i:=1 to MaxFiles do begin
   Y:=i*9;
   X:=20;
   While Y>180 do begin
    Y:=Y-180;
    X:=X+80;
   End;
   PlaceText(X,Y,Files[i],Color,Place);
  End;
 End;

 Procedure PlaceFileBox(X1,Y1,X2,Y2,CurrentFile:Integer;Path:String;Color:Byte;Place:Word);
 Var
  S,FPos,X,Y,i,i2,i3:Integer;
 Begin
  For i:=1 to MaxFiles do Files[i]:=' ';
  GetFiles(Path);
  Y:=Y1+10-FontLength;
  X:=X1;
  FPos:=0;
  If Length(DirStart)<4 then S:=-1
  Else S:=0;

  If CurrentFile-3*(10)>FPos then FPos:=FPos+((CurrentFile div 10)*10)-10;
  For i:=S to MaxFiles-2 do begin
   Y:=Y+FontLength;
   While Y+FontLength>Y2+1 do begin
    Y:=Y1+10;
    X:=X+13*FontWidth;
   End;


   If (X+FontWidth*Length(Files[FPos+i+1])<X2) then begin
    If CurrentFile=FPos+i+1 then begin
     For i3:=Y to Y+7 do For i2:=X-1 to X+FontWidth*Length(Files[FPos+i+1])-1 do
     Mem[Place:320*i3+i2]:=Color;
     PlaceText(X,Y,Files[FPos+i+1],0,Place);
    End;
    If CurrentFile<>FPos+i+1 then PlaceText(X,Y,Files[FPos+i+1],Color,Place);
   End;
  End;
 End;


 Procedure PickFile(X1,Y1,X2,Y2:Integer;Path:String;Place,PPlace,PCutPlace:Word);
 Var
  T,PAct,i,i2,ClickedOn,ClickTimer:Integer;
  RefreshEnterBox,RefreshFileBox:Boolean;
 Begin
  St:=FileStart;
  For i:=1 to MaxFiles-1 do
  If St>Files[CurrentFile] then begin
   CurrentFile:=CurrentFile+1;
   RefreshFileBox:=True;
  End;
  TextC:=White;

  FType:='UnSpecified';
  If FileStart='*.*' then FType:='All Files';
  If (UpCase(FileStart[Length(FileStart)-3])='.')and
  (UpCase(FileStart[Length(FileStart)-2])='D')and
  (UpCase(FileStart[Length(FileStart)-1])='P')and
  (UpCase(FileStart[Length(FileStart)])='C') then
  FType:='DPC GHB Data Picture';
  If (UpCase(FileStart[Length(FileStart)-3])='.')and
  (UpCase(FileStart[Length(FileStart)-2])='P')and
  (UpCase(FileStart[Length(FileStart)-1])='C')and
  (UpCase(FileStart[Length(FileStart)])='X') then
  FType:='PCX ZSoft Paintbrush';
  If (UpCase(FileStart[Length(FileStart)-3])='.')and
  (UpCase(FileStart[Length(FileStart)-2])='G')and
  (UpCase(FileStart[Length(FileStart)-1])='G')and
  (UpCase(FileStart[Length(FileStart)])='X') then
  FType:='GGX Glen''s Art File';


  If (Length(DirStart)<4) then CurrentFile:=-5
  Else CurrentFile:=-100;

  PlaceBoard(X1,Y1,X2,Y2,0,0,0,MenuBarC,MenuBarC,Place);
  For i2:=Y1+1 to Y1+11 do For i:=X1+1 to X2-1 do Mem[Place:320*i2+i]:=MenuBarHC;
  For i2:=Y1+35 to Y2-26 do For i:=X1+3 to X2-3 do Mem[Place:320*i2+i]:=0;
  For i2:=Y1+15 to Y1+24 do For i:=X1+3 to X1+100 do Mem[Place:320*i2+i]:=0;

  For i2:=Y2-20 to Y2-10 do For i:=X1+3 to X1+122 do Mem[Place:320*i2+i]:=0;
  For i2:=Y2-23 to Y2-3 do For i:=X1+135 to X2-3 do Mem[Place:320*i2+i]:=0;

  PlaceButton(X2-10,Y1+2,1,1,Place);
  PlaceButton(X1+124,Y2-19,7,1,Place);
  PlaceFileBox(X1+4,Y1+21+4,X2-3,Y2-26,CurrentFile,Path,White,Place);
  PlaceText(X1+4,Y1+2,'Loading File',TextC,Place);
  PlaceText(X1+4,Y1+26,Path,0,Place);
  PlaceText(X1+4,Y1+16,St,TextC,Place);

  PlaceText(X1+4,Y2-19,FType,TextC,Place);

  MouseProcess3;
  MouseProcess1;
  Flip(Place,VidSeg,0);
  MouseProcess2;

  CurrentFile:=1;
  RefreshFileBox:=True;
  T:=1;
  For i:=0 to MaxFiles do Files[i]:=' ';

  Repeat
   MouseProcess3;
   MouseProcess1;
   Flip(Place,VidSeg,0);
   Delay(50);
   MouseProcess2;
   Key:='~';
   PAct:=1;

   T:=T*-1;
   ClickTimer:=ClickTimer-1;
   If ClickTimer<0 then ClickTimer:=0;

   If T=1 then
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=TextC
   Else
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=0;

   If LeftPressed then PAct:=2;
   If RightPressed then PAct:=3;

   If Keypressed then Key:=Readkey;
   If (PAct=2) then begin
    If (X2-1>PX)and(X2-11<PX)and(Y1+11>PY)and(Y1+1<PY)then begin
     Key:=Chr(27);
     PlaceButton(X2-10,Y1+2,1,2,VidSeg);
    End;
    If (X1+124+9>PX)and(X1+124-1<PX)and(Y2-19+9>PY)and(Y2-19-1<PY)then begin
     PlaceButton(X1+124,Y2-19,7,1,Place);
     If (FType='GGX Glen''s Art File') then begin
      FType:='PCX ZSoft Paintbrush';
      St:='*.PCX';
     End
     Else begin
      If (FType='PCX ZSoft Paintbrush') then begin
       FType:='DPC GHB Data Picture';
       St:='*.DPC';
      End
      Else begin
       If (FType='DPC GHB Data Picture') then begin
        FType:='All Files';
        St:='*.*';
       End
       Else begin
        If (FType='All Files') then begin
         FType:='GGX Glen''s Art File';
         St:='*.GGX';
        End;
       End;
      End;
     End;
     Path:=DirStart+St;
     RefreshEnterBox:=True;
     RefreshFileBox:=True;
     Delay(50);
     For i2:=Y2-20 to Y2-10 do For i:=X1+3 to X1+122 do Mem[Place:320*i2+i]:=0;
     PlaceText(X1+4,Y2-19,FType,TextC,Place);
    End;
    {PlaceButton(X2-10,Y1+2,1,1,Place);
    PlaceButton(X1+124,Y2-19,7,1,Place);}
   End;

   If (PAct=2)and(PY>(Y1+30))and(PY<(Y2-25)) then begin
    If CurrentFile>30 then begin
     If ((PX-(X1+4))div (13*FontWidth)>=1) then
     CurrentFile:=CurrentFile+10;
     If ((PX-(X1+4))div (13*FontWidth)<2) then
     CurrentFile:=CurrentFile-10;
     CurrentFile:=(CurrentFile div 10)*10+(PY-(Y1+27))div 8;
    End
    Else
    CurrentFile:=((PX-(X1+4))div (13*FontWidth)) *10 +(PY-(Y1+27))div 8;
    If (Length(DirStart)<4) then CurrentFile:=CurrentFile-1;
    If (ClickTimer>0)and(ClickedOn=CurrentFile) then begin
     Key:=chr(13);
    End;
    ClickedOn:=CurrentFile;
    ClickTimer:=5;
    Delay(50);
    RefreshEnterBox:=True;
    RefreshFileBox:=True;
   End;

   If ((Key>='A')and(Key<='z'))or((Key>='0')and(Key<='9')or
   (Key in ['*','.','<','>',':',' '])) then begin
    St:=St+Key;
    RefreshEnterBox:=True;
   End;

   If (Length(St)>12) then Delete(St,13,Length(St)+1);
   If Key=chr(8) then begin
    Delete(St,Length(St),Length(St)+1);
    RefreshEnterBox:=True;
   End;

   If Key=Chr(0) then begin
    Key:=ReadKey;
    If Key='H' then CurrentFile:=CurrentFile-1;
    If Key='P' then CurrentFile:=CurrentFile+1;
    If Key='K' then CurrentFile:=CurrentFile-((Y2-Y1-FontLength) div FontLength)+6;
    If Key='M' then CurrentFile:=CurrentFile+((Y2-Y1-FontLength) div FontLength)-6;
    If ((Key='H')or(Key='P')or(Key='K')or(Key='M')) then begin
     RefreshEnterBox:=True;
     RefreshFileBox:=True;
    End;
   End;

   If RefreshEnterBox then begin
    RefreshEnterBox:=False;
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=0;
    For i2:=Y1+15 to Y1+24 do For i:=X1+3 to X1+100 do Mem[Place:320*i2+i]:=0;
    PlaceText(X1+4,Y1+16,St,TextC,Place);
   End;

   If (Length(DirStart)>3)and(CurrentFile<1) then CurrentFile:=1
   Else If (CurrentFile<-1) then CurrentFile:=-1;

   If CurrentFile>MaxFiles-1 then CurrentFile:=MaxFiles-1;

   If RefreshFileBox then begin
    RefreshFileBox:=False;
    For i2:=Y1+35 to Y2-26 do For i:=X1+3 to X2-3 do Mem[Place:320*i2+i]:=0;
    PlaceFileBox(X1+4,Y1+21+4,X2-3,Y2-26,CurrentFile,Path,White,Place);

    For i2:=Y2-23 to Y2-3 do For i:=X1+135 to X2-3 do Mem[Place:320*i2+i]:=0;
    FindFirst(DirStart+Files[CurrentFile],AnyFile,DirInfo);
    PlaceText(X1+140,Y2-22,'Size: '+I2S(DirInfo.Size),TextC,Place);
   End;
  Until (Key=Chr(13))or(Key=Chr(27));
  If Key=Chr(27) then St:='EXIT';
 End;

 Procedure SaveFile(X1,Y1,X2,Y2:Integer;Path:String;Place,PPlace,PCutPlace:Word);
 Var
  T,PAct,i,i2,ClickedOn,ClickTimer:Integer;
  RefreshEnterBox,RefreshFileBox:Boolean;
 Begin
  St:=FileStart;
  For i:=1 to MaxFiles-1 do
  If St>Files[CurrentFile] then begin
   CurrentFile:=CurrentFile+1;
   RefreshFileBox:=True;
  End;
  TextC:=White;

  FType:='DPC & GGX Only!';
  If (UpCase(FileStart[Length(FileStart)-3])='.')and
  (UpCase(FileStart[Length(FileStart)-2])='D')and
  (UpCase(FileStart[Length(FileStart)-1])='P')and
  (UpCase(FileStart[Length(FileStart)])='C') then
  FType:='DPC GHB Data Picture';
  If (UpCase(FileStart[Length(FileStart)-3])='.')and
  (UpCase(FileStart[Length(FileStart)-2])='G')and
  (UpCase(FileStart[Length(FileStart)-1])='G')and
  (UpCase(FileStart[Length(FileStart)])='X') then
  FType:='GGX Glen''s Art File';


  If (Length(DirStart)<4) then CurrentFile:=-5
  Else CurrentFile:=-100;

  PlaceBoard(X1,Y1,X2,Y2,0,0,0,MenuBarC,MenuBarC,Place);
  For i2:=Y1+1 to Y1+11 do For i:=X1+1 to X2-1 do Mem[Place:320*i2+i]:=MenuBarHC;
  For i2:=Y1+35 to Y2-26 do For i:=X1+3 to X2-3 do Mem[Place:320*i2+i]:=0;
  For i2:=Y1+15 to Y1+24 do For i:=X1+3 to X1+100 do Mem[Place:320*i2+i]:=0;

  For i2:=Y2-20 to Y2-10 do For i:=X1+3 to X1+122 do Mem[Place:320*i2+i]:=0;
  For i2:=Y2-23 to Y2-3 do For i:=X1+135 to X2-3 do Mem[Place:320*i2+i]:=0;

  PlaceButton(X2-10,Y1+2,1,1,Place);
  PlaceButton(X1+124,Y2-19,7,1,Place);
  PlaceFileBox(X1+4,Y1+21+4,X2-3,Y2-26,CurrentFile,Path,White,Place);
  PlaceText(X1+4,Y1+2,'Saving File',TextC,Place);
  PlaceText(X1+4,Y1+26,Path,0,Place);
  PlaceText(X1+4,Y1+16,St,TextC,Place);

  PlaceText(X1+4,Y2-19,FType,TextC,Place);

  MouseProcess3;
  MouseProcess1;
  Flip(Place,VidSeg,0);
  MouseProcess2;

  CurrentFile:=1;
  RefreshFileBox:=True;
  T:=1;
  For i:=0 to MaxFiles do Files[i]:=' ';

  Repeat
   MouseProcess3;
   MouseProcess1;
   Flip(Place,VidSeg,0);
   Delay(50);
   MouseProcess2;
   Key:='~';
   PAct:=1;

   T:=T*-1;
   ClickTimer:=ClickTimer-1;
   If ClickTimer<0 then ClickTimer:=0;

   If T=1 then
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=TextC
   Else
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=0;

   If LeftPressed then PAct:=2;
   If RightPressed then PAct:=3;

   If Keypressed then Key:=Readkey;
   If (PAct=2) then begin
    If (X2-1>PX)and(X2-11<PX)and(Y1+11>PY)and(Y1+1<PY)then begin
     Key:=Chr(27);
     PlaceButton(X2-10,Y1+2,1,2,VidSeg);
    End;
    If (X1+124+9>PX)and(X1+124-1<PX)and(Y2-19+9>PY)and(Y2-19-1<PY)then begin
     PlaceButton(X1+124,Y2-19,7,1,Place);
     If (FType='GGX Glen''s Art File') then begin
      FType:='DPC GHB Data Picture';
      St:='*.DPC';
     End
     Else begin
      If (FType='DPC GHB Data Picture') then begin
       FType:='GGX Glen''s Art File';
       St:='*.GGX';
      End;
     End;
     Path:=DirStart+St;
     RefreshEnterBox:=True;
     RefreshFileBox:=True;
     Delay(50);
     For i2:=Y2-20 to Y2-10 do For i:=X1+3 to X1+122 do Mem[Place:320*i2+i]:=0;
     PlaceText(X1+4,Y2-19,FType,TextC,Place);
    End;
   End;

   If (PAct=2)and(PY>(Y1+30))and(PY<(Y2-25)) then begin
    If CurrentFile>30 then begin
     If ((PX-(X1+4))div (13*FontWidth)>=1) then
     CurrentFile:=CurrentFile+10;
     If ((PX-(X1+4))div (13*FontWidth)<2) then
     CurrentFile:=CurrentFile-10;
     CurrentFile:=(CurrentFile div 10)*10+(PY-(Y1+27))div 8;
    End
    Else
    CurrentFile:=((PX-(X1+4))div (13*FontWidth)) *10 +(PY-(Y1+27))div 8;
    If (Length(DirStart)<4) then CurrentFile:=CurrentFile-1;
    If (ClickTimer>0)and(ClickedOn=CurrentFile) then begin
     Key:=chr(13);
    End;
    ClickedOn:=CurrentFile;
    ClickTimer:=5;
    Delay(50);
    RefreshEnterBox:=True;
    RefreshFileBox:=True;
   End;

   If ((Key>='A')and(Key<='z'))or((Key>='0')and(Key<='9')or
   (Key in ['*','.','<','>',':',' '])) then begin
    St:=St+Key;
    RefreshEnterBox:=True;
   End;

   If (Length(St)>12) then Delete(St,13,Length(St)+1);
   If Key=chr(8) then begin
    Delete(St,Length(St),Length(St)+1);
    RefreshEnterBox:=True;
   End;

   If Key=Chr(0) then begin
    Key:=ReadKey;
    If Key='H' then CurrentFile:=CurrentFile-1;
    If Key='P' then CurrentFile:=CurrentFile+1;
    If Key='K' then CurrentFile:=CurrentFile-((Y2-Y1-FontLength) div FontLength)+6;
    If Key='M' then CurrentFile:=CurrentFile+((Y2-Y1-FontLength) div FontLength)-6;
    If ((Key='H')or(Key='P')or(Key='K')or(Key='M')) then begin
     RefreshEnterBox:=True;
     RefreshFileBox:=True;
    End;
   End;

   If RefreshEnterBox then begin
    RefreshEnterBox:=False;
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=0;
    For i2:=Y1+15 to Y1+24 do For i:=X1+3 to X1+100 do Mem[Place:320*i2+i]:=0;
    PlaceText(X1+4,Y1+16,St,TextC,Place);
   End;

   If (Length(DirStart)>3)and(CurrentFile<1) then CurrentFile:=1
   Else If (CurrentFile<-1) then CurrentFile:=-1;

   If CurrentFile>MaxFiles-1 then CurrentFile:=MaxFiles-1;

   If RefreshFileBox then begin
    RefreshFileBox:=False;
    For i2:=Y1+35 to Y2-26 do For i:=X1+3 to X2-3 do Mem[Place:320*i2+i]:=0;
    PlaceFileBox(X1+4,Y1+21+4,X2-3,Y2-26,CurrentFile,Path,White,Place);

    For i2:=Y2-23 to Y2-3 do For i:=X1+135 to X2-3 do Mem[Place:320*i2+i]:=0;
    FindFirst(DirStart+Files[CurrentFile],AnyFile,DirInfo);
    PlaceText(X1+140,Y2-22,'Size: '+I2S(DirInfo.Size),TextC,Place);
   End;
  Until (Key=Chr(13))or(Key=Chr(27));
  If Key=Chr(27) then St:='EXIT';
  If Key=Chr(13) then begin
   CFile:=St;
  End;
 End;




 Procedure SavePal(X1,Y1,X2,Y2:Integer;Path:String;Place,PPlace,PCutPlace:Word);
 Var
  T,PAct,i,i2,ClickedOn,ClickTimer:Integer;
  RefreshEnterBox,RefreshFileBox:Boolean;
 Begin
  St:=FileStart;
  For i:=1 to MaxFiles-1 do
  If St>Files[CurrentFile] then begin
   CurrentFile:=CurrentFile+1;
   RefreshFileBox:=True;
  End;
  TextC:=White;

  FType:='PAL or GPL Only!';
  If (UpCase(FileStart[Length(FileStart)-3])='.')and
  (UpCase(FileStart[Length(FileStart)-2])='P')and
  (UpCase(FileStart[Length(FileStart)-1])='A')and
  (UpCase(FileStart[Length(FileStart)])='L') then
  FType:='PAL GHB Data Palette';
  If (UpCase(FileStart[Length(FileStart)-3])='.')and
  (UpCase(FileStart[Length(FileStart)-2])='G')and
  (UpCase(FileStart[Length(FileStart)-1])='P')and
  (UpCase(FileStart[Length(FileStart)])='L') then
  FType:='GPL GHB Art Palette';


  If (Length(DirStart)<4) then CurrentFile:=-5
  Else CurrentFile:=-100;

  PlaceBoard(X1,Y1,X2,Y2,0,0,0,MenuBarC,MenuBarC,Place);
  For i2:=Y1+1 to Y1+11 do For i:=X1+1 to X2-1 do Mem[Place:320*i2+i]:=MenuBarHC;
  For i2:=Y1+35 to Y2-26 do For i:=X1+3 to X2-3 do Mem[Place:320*i2+i]:=0;
  For i2:=Y1+15 to Y1+24 do For i:=X1+3 to X1+100 do Mem[Place:320*i2+i]:=0;

  For i2:=Y2-20 to Y2-10 do For i:=X1+3 to X1+122 do Mem[Place:320*i2+i]:=0;
  For i2:=Y2-23 to Y2-3 do For i:=X1+135 to X2-3 do Mem[Place:320*i2+i]:=0;

  PlaceButton(X2-10,Y1+2,1,1,Place);
  PlaceButton(X1+124,Y2-19,7,1,Place);
  PlaceFileBox(X1+4,Y1+21+4,X2-3,Y2-26,CurrentFile,Path,White,Place);
  PlaceText(X1+4,Y1+2,'Saving Palette',TextC,Place);
  PlaceText(X1+4,Y1+26,Path,0,Place);
  PlaceText(X1+4,Y1+16,St,TextC,Place);

  PlaceText(X1+4,Y2-19,FType,TextC,Place);

  MouseProcess3;
  MouseProcess1;
  Flip(Place,VidSeg,0);
  MouseProcess2;

  CurrentFile:=1;
  RefreshFileBox:=True;
  T:=1;
  For i:=0 to MaxFiles do Files[i]:=' ';

  Repeat
   MouseProcess3;
   MouseProcess1;
   Flip(Place,VidSeg,0);
   Delay(50);
   MouseProcess2;
   Key:='~';
   PAct:=1;

   T:=T*-1;
   ClickTimer:=ClickTimer-1;
   If ClickTimer<0 then ClickTimer:=0;

   If T=1 then
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=TextC
   Else
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=0;

   If LeftPressed then PAct:=2;
   If RightPressed then PAct:=3;

   If Keypressed then Key:=Readkey;
   If (PAct=2) then begin
    If (X2-1>PX)and(X2-11<PX)and(Y1+11>PY)and(Y1+1<PY)then begin
     Key:=Chr(27);
     PlaceButton(X2-10,Y1+2,1,2,VidSeg);
    End;
    If (X1+124+9>PX)and(X1+124-1<PX)and(Y2-19+9>PY)and(Y2-19-1<PY)then begin
     PlaceButton(X1+124,Y2-19,7,1,Place);
     If (FType='GPL GHB Art Palette') then begin
      FType:='PAL GHB Data Palette';
      St:='*.PAL';
     End
     Else begin
      If (FType='PAL GHB Data Palette') then begin
       FType:='GPL GHB Art Pal';
       St:='*.GPL';
      End;
     End;
     Path:=DirStart+St;
     RefreshEnterBox:=True;
     RefreshFileBox:=True;
     Delay(50);
     For i2:=Y2-20 to Y2-10 do For i:=X1+3 to X1+122 do Mem[Place:320*i2+i]:=0;
     PlaceText(X1+4,Y2-19,FType,TextC,Place);
    End;
   End;

   If (PAct=2)and(PY>(Y1+30))and(PY<(Y2-25)) then begin
    If CurrentFile>30 then begin
     If ((PX-(X1+4))div (13*FontWidth)>=1) then
     CurrentFile:=CurrentFile+10;
     If ((PX-(X1+4))div (13*FontWidth)<2) then
     CurrentFile:=CurrentFile-10;
     CurrentFile:=(CurrentFile div 10)*10+(PY-(Y1+27))div 8;
    End
    Else
    CurrentFile:=((PX-(X1+4))div (13*FontWidth)) *10 +(PY-(Y1+27))div 8;
    If (Length(DirStart)<4) then CurrentFile:=CurrentFile-1;
    If (ClickTimer>0)and(ClickedOn=CurrentFile) then begin
     Key:=chr(13);
    End;
    ClickedOn:=CurrentFile;
    ClickTimer:=5;
    Delay(50);
    RefreshEnterBox:=True;
    RefreshFileBox:=True;
   End;

   If ((Key>='A')and(Key<='z'))or((Key>='0')and(Key<='9')or
   (Key in ['*','.','<','>',':',' '])) then begin
    St:=St+Key;
    RefreshEnterBox:=True;
   End;

   If (Length(St)>12) then Delete(St,13,Length(St)+1);
   If Key=chr(8) then begin
    Delete(St,Length(St),Length(St)+1);
    RefreshEnterBox:=True;
   End;

   If Key=Chr(0) then begin
    Key:=ReadKey;
    If Key='H' then CurrentFile:=CurrentFile-1;
    If Key='P' then CurrentFile:=CurrentFile+1;
    If Key='K' then CurrentFile:=CurrentFile-((Y2-Y1-FontLength) div FontLength)+6;
    If Key='M' then CurrentFile:=CurrentFile+((Y2-Y1-FontLength) div FontLength)-6;
    If ((Key='H')or(Key='P')or(Key='K')or(Key='M')) then begin
     RefreshEnterBox:=True;
     RefreshFileBox:=True;
    End;
   End;

   If RefreshEnterBox then begin
    RefreshEnterBox:=False;
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=0;
    For i2:=Y1+15 to Y1+24 do For i:=X1+3 to X1+100 do Mem[Place:320*i2+i]:=0;
    PlaceText(X1+4,Y1+16,St,TextC,Place);
   End;

   If (Length(DirStart)>3)and(CurrentFile<1) then CurrentFile:=1
   Else If (CurrentFile<-1) then CurrentFile:=-1;

   If CurrentFile>MaxFiles-1 then CurrentFile:=MaxFiles-1;

   If RefreshFileBox then begin
    RefreshFileBox:=False;
    For i2:=Y1+35 to Y2-26 do For i:=X1+3 to X2-3 do Mem[Place:320*i2+i]:=0;
    PlaceFileBox(X1+4,Y1+21+4,X2-3,Y2-26,CurrentFile,Path,White,Place);

    For i2:=Y2-23 to Y2-3 do For i:=X1+135 to X2-3 do Mem[Place:320*i2+i]:=0;
    FindFirst(DirStart+Files[CurrentFile],AnyFile,DirInfo);
    PlaceText(X1+140,Y2-22,'Size: '+I2S(DirInfo.Size),TextC,Place);
   End;
  Until (Key=Chr(13))or(Key=Chr(27));
  If Key=Chr(27) then St:='EXIT';
  If Key=Chr(13) then begin
   CFile:=St;
  End;
 End;



 Procedure LoadPal(X1,Y1,X2,Y2:Integer;Path:String;Place,PPlace,PCutPlace:Word);
 Var
  T,PAct,i,i2,ClickedOn,ClickTimer:Integer;
  RefreshEnterBox,RefreshFileBox:Boolean;
 Begin
  St:=FileStart;
  For i:=1 to MaxFiles-1 do
  If St>Files[CurrentFile] then begin
   CurrentFile:=CurrentFile+1;
   RefreshFileBox:=True;
  End;
  TextC:=White;

  FType:='PAL or GPL Only!';
  If (UpCase(FileStart[Length(FileStart)-3])='.')and
  (UpCase(FileStart[Length(FileStart)-2])='P')and
  (UpCase(FileStart[Length(FileStart)-1])='A')and
  (UpCase(FileStart[Length(FileStart)])='L') then
  FType:='PAL GHB Data Palette';
  If (UpCase(FileStart[Length(FileStart)-3])='.')and
  (UpCase(FileStart[Length(FileStart)-2])='G')and
  (UpCase(FileStart[Length(FileStart)-1])='P')and
  (UpCase(FileStart[Length(FileStart)])='L') then
  FType:='GPL GHB Art Palette';


  If (Length(DirStart)<4) then CurrentFile:=-5
  Else CurrentFile:=-100;

  PlaceBoard(X1,Y1,X2,Y2,0,0,0,MenuBarC,MenuBarC,Place);
  For i2:=Y1+1 to Y1+11 do For i:=X1+1 to X2-1 do Mem[Place:320*i2+i]:=MenuBarHC;
  For i2:=Y1+35 to Y2-26 do For i:=X1+3 to X2-3 do Mem[Place:320*i2+i]:=0;
  For i2:=Y1+15 to Y1+24 do For i:=X1+3 to X1+100 do Mem[Place:320*i2+i]:=0;

  For i2:=Y2-20 to Y2-10 do For i:=X1+3 to X1+122 do Mem[Place:320*i2+i]:=0;
  For i2:=Y2-23 to Y2-3 do For i:=X1+135 to X2-3 do Mem[Place:320*i2+i]:=0;

  PlaceButton(X2-10,Y1+2,1,1,Place);
  PlaceButton(X1+124,Y2-19,7,1,Place);
  PlaceFileBox(X1+4,Y1+21+4,X2-3,Y2-26,CurrentFile,Path,White,Place);
  PlaceText(X1+4,Y1+2,'Loading Palette',TextC,Place);
  PlaceText(X1+4,Y1+26,Path,0,Place);
  PlaceText(X1+4,Y1+16,St,TextC,Place);

  PlaceText(X1+4,Y2-19,FType,TextC,Place);

  MouseProcess3;
  MouseProcess1;
  Flip(Place,VidSeg,0);
  MouseProcess2;

  CurrentFile:=1;
  RefreshFileBox:=True;
  T:=1;
  For i:=0 to MaxFiles do Files[i]:=' ';

  Repeat
   MouseProcess3;
   MouseProcess1;
   Flip(Place,VidSeg,0);
   Delay(50);
   MouseProcess2;
   Key:='~';
   PAct:=1;

   T:=T*-1;
   ClickTimer:=ClickTimer-1;
   If ClickTimer<0 then ClickTimer:=0;

   If T=1 then
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=TextC
   Else
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=0;

   If LeftPressed then PAct:=2;
   If RightPressed then PAct:=3;

   If Keypressed then Key:=Readkey;
   If (PAct=2) then begin
    If (X2-1>PX)and(X2-11<PX)and(Y1+11>PY)and(Y1+1<PY)then begin
     Key:=Chr(27);
     PlaceButton(X2-10,Y1+2,1,2,VidSeg);
    End;
    If (X1+124+9>PX)and(X1+124-1<PX)and(Y2-19+9>PY)and(Y2-19-1<PY)then begin
     PlaceButton(X1+124,Y2-19,7,1,Place);
     If (FType='GPL GHB Art Palette') then begin
      FType:='PAL GHB Data Palette';
      St:='*.PAL';
     End
     Else begin
      If (FType='PAL GHB Data Palette') then begin
       FType:='GPL GHB Art Pal';
       St:='*.GPL';
      End;
     End;
     Path:=DirStart+St;
     RefreshEnterBox:=True;
     RefreshFileBox:=True;
     Delay(50);
     For i2:=Y2-20 to Y2-10 do For i:=X1+3 to X1+122 do Mem[Place:320*i2+i]:=0;
     PlaceText(X1+4,Y2-19,FType,TextC,Place);
    End;
   End;

   If (PAct=2)and(PY>(Y1+30))and(PY<(Y2-25)) then begin
    If CurrentFile>30 then begin
     If ((PX-(X1+4))div (13*FontWidth)>=1) then
     CurrentFile:=CurrentFile+10;
     If ((PX-(X1+4))div (13*FontWidth)<2) then
     CurrentFile:=CurrentFile-10;
     CurrentFile:=(CurrentFile div 10)*10+(PY-(Y1+27))div 8;
    End
    Else
    CurrentFile:=((PX-(X1+4))div (13*FontWidth)) *10 +(PY-(Y1+27))div 8;
    If (Length(DirStart)<4) then CurrentFile:=CurrentFile-1;
    If (ClickTimer>0)and(ClickedOn=CurrentFile) then begin
     Key:=chr(13);
    End;
    ClickedOn:=CurrentFile;
    ClickTimer:=5;
    Delay(50);
    RefreshEnterBox:=True;
    RefreshFileBox:=True;
   End;

   If ((Key>='A')and(Key<='z'))or((Key>='0')and(Key<='9')or
   (Key in ['*','.','<','>',':',' '])) then begin
    St:=St+Key;
    RefreshEnterBox:=True;
   End;

   If (Length(St)>12) then Delete(St,13,Length(St)+1);
   If Key=chr(8) then begin
    Delete(St,Length(St),Length(St)+1);
    RefreshEnterBox:=True;
   End;

   If Key=Chr(0) then begin
    Key:=ReadKey;
    If Key='H' then CurrentFile:=CurrentFile-1;
    If Key='P' then CurrentFile:=CurrentFile+1;
    If Key='K' then CurrentFile:=CurrentFile-((Y2-Y1-FontLength) div FontLength)+6;
    If Key='M' then CurrentFile:=CurrentFile+((Y2-Y1-FontLength) div FontLength)-6;
    If ((Key='H')or(Key='P')or(Key='K')or(Key='M')) then begin
     RefreshEnterBox:=True;
     RefreshFileBox:=True;
    End;
   End;

   If RefreshEnterBox then begin
    RefreshEnterBox:=False;
    For i2:=Y1+17 to Y1+22 do Mem[Place:320*i2+X1+FontWidth*(Length(St)+1)-2]:=0;
    For i2:=Y1+15 to Y1+24 do For i:=X1+3 to X1+100 do Mem[Place:320*i2+i]:=0;
    PlaceText(X1+4,Y1+16,St,TextC,Place);
   End;

   If (Length(DirStart)>3)and(CurrentFile<1) then CurrentFile:=1
   Else If (CurrentFile<-1) then CurrentFile:=-1;

   If CurrentFile>MaxFiles-1 then CurrentFile:=MaxFiles-1;

   If RefreshFileBox then begin
    RefreshFileBox:=False;
    For i2:=Y1+35 to Y2-26 do For i:=X1+3 to X2-3 do Mem[Place:320*i2+i]:=0;
    PlaceFileBox(X1+4,Y1+21+4,X2-3,Y2-26,CurrentFile,Path,White,Place);

    For i2:=Y2-23 to Y2-3 do For i:=X1+135 to X2-3 do Mem[Place:320*i2+i]:=0;
    FindFirst(DirStart+Files[CurrentFile],AnyFile,DirInfo);
    PlaceText(X1+140,Y2-22,'Size: '+I2S(DirInfo.Size),TextC,Place);
   End;
  Until (Key=Chr(13))or(Key=Chr(27));
  If Key=Chr(27) then St:='EXIT';
  If Key=Chr(13) then begin
   CFile:=St;
  End;
 End;













 Procedure GDIRS(BoardC,HC,TextC,Opt:Byte);
 Label
  L1;
 Begin
  GetPCutSeg(0,0,VidSeg);
  MouseProcess3;
  MouseProcess1;
  MouseProcess2;
  If Opt=1 then FileStart:='*.DPC';
  If Opt=2 then FileStart:='*.DPC';
  If Opt=3 then FileStart:='*.PAL';
  If Opt=4 then FileStart:='*.PAL';

 L1:
  If DirStart[Length(DirStart)]<>'\' then DirStart:=DirStart+'\';
  If Opt=1 then PickFile(40,30,280,170,DirStart+FileStart,VirSeg,P1Seg,PCutSeg);
  If Opt=2 then SaveFile(40,30,280,170,DirStart+FileStart,VirSeg,P1Seg,PCutSeg);
  If Opt=3 then LoadPal(40,30,280,170,DirStart+FileStart,VirSeg,P1Seg,PCutSeg);
  If Opt=4 then SavePal(40,30,280,170,DirStart+FileStart,VirSeg,P1Seg,PCutSeg);

  CFile:=St;
  If CFile<>'EXIT' then begin
   CFile[1]:=UpCase(CFile[1]);
   If (CFile='A:')or(CFile='A:\') then begin
    DirStart:='A:\';
    St:='*.*';
    Goto L1;
   End;
   If (CFile='B:')or(CFile='B:\') then begin
    DirStart:='B:\';
    St:='*.*';
    Goto L1;
   End;
   If (CFile='C:')or(CFile='C:\') then begin
    DirStart:='C:\';
    St:='*.*';
    Goto L1;
   End;
   If (CFile='D:')or(CFile='D:\') then begin
    DirStart:='D:\';
    St:='*.*';
    Goto L1;
   End;

   If St=FileStart then St:=Files[CurrentFile]
   Else
   If (Opt=1)or(St='*.*')or(((Opt=3)or(Opt=4))and((St='*.PAL')or(St='*.GPL'))) then begin
    FileStart:=St;
    Goto L1;
   End;

   CFile:=St;

   If CFile='..' then begin
    i:=Length(DirStart)-2;
    Repeat
     St:=DirStart[i];
     i:=i-1;
    Until St='\';
    Delete(DirStart,i+2,Length(DirStart)+1);
    If FileStart='..' then FileStart:='*.*';
    St:='*.*';
    Goto L1;
   End;


   If ((CFile[1]='<')and(CFile[Length(CFile)]='>')) then begin
    For i:=1 to Length(CFile) do
    If (CFile[i]='<') then Delete(CFile,i,i);
    For i:=1 to Length(CFile) do
    If (CFile[i]='>') then CFile[i]:='\';
    DirStart:=DirStart+CFile;
    Goto L1;
   End;
  End;
  Key:='~';
 End;

 Procedure UNDO;
 Begin
  SaveDPC('UNDO2.DAT',GGXSeg);
  CLS(GGXSeg);
  PlaceDPC(0,0,0,'UNDO.DAT',GGXSeg);

  Assign(PicFile,'UNDO.DAT');
  Erase(PicFile);
  Assign(PicFile,'UNDO2.DAT');
  Rename(PicFile,'UNDO.DAT');

  PlaceMainStuff(VirSeg);
  PlaceWindows(VirSeg);
  PlaceColorBoard(VirSeg);
  If ShowPCords then PlacePCords(VirSeg);
  If ShowTStuff then PlaceTStuff(VirSeg);
  If ShowPrompt then PlacePrompt(VirSeg);
 End;


























 BEGIN
  PALETTEFILENAME:='GART2.PAL';

  SetVGA;
  FadetoBlack(1);
  PlaceDPC(160,100,1,'GCLAIMER.DPX',VidSeg);
  Fadeto('GCLAIMER.PAL',25);

  Delay(20);

  GetMem(VirScr,320*200); VirSeg:=Seg(VirScr^); CLS(VirSeg);
  GetMem(GGXScr,MaxGGXWidth*MaxGGXLength); GGXSeg:=Seg(GGXScr^); CLS(GGXSeg);

  GetMem(P1Scr,20*20); P1Seg:=Seg(P1Scr^);
  GetMem(P2Scr,20*20); P2Seg:=Seg(P2Scr^);
  GetMem(P3Scr,20*20); P3Seg:=Seg(P3Scr^);
  GetMem(PCutScr,20*20); PCutSeg:=Seg(PCutScr^);
  For i3:=0 to 399 do Mem[P1Seg:i3]:=0;
  For i3:=0 to 399 do Mem[P2Seg:i3]:=0;
  For i3:=0 to 399 do Mem[P3Seg:i3]:=0;
  For i3:=0 to 399 do Mem[PCutSeg:i3]:=0;

  LoadFont('GART.GFT');

  MouseInstalled;
  PType:=1;
  LoadPSeg(PType);
  GetPCutSeg(0,0,VidSeg);
  PAct:=1;

  GetDir(0,DirStart);
  FileStart:='*.DPC';
  SelectC1:=White;
  SelectC2:=Black;
  BackGroundC:=Purple-8;

  ButtonC:=White-6;
  ButtonHC:=0;

  BodyBarC:=White-6;
  MenuBarC:=BodyBarC;
  MenuBarHC:=0;
  MenuBarTextC:=BodyBarC;
  MenuBarHTextC:=White;
  SysRC:=230;

  PlaceMainStuff(VirSeg);

  ShowPCords:=True;
  ShowTStuff:=True;
  ShowPrompt:=True;

  Button[1].X:=308;
  Button[1].Y:=3;
  Button[1].BType:=1;
  Button[1].BAct:=1;
  CurrentButtons:=1;
  {308,3,1}

  For i3:=1 to CurrentButtons do PlaceButton(Button[i3].X,Button[i3].Y,Button[i3].BType,Button[i3].BAct,VirSeg);


  GGXWidth:=31;
  GGXLength:=31;
  MenuOpt:=0;

  ColorBoardX:=0;
  ColorBoardY:=164;{176}

  For i2:= 0 to GGXLength-1 do
  For i:= 0 to GGXWidth-1 do begin
   Mem[GGXSeg:320*i2+i]:=31+(i2+i)*2;
  End;

  Randomize;
  R:=Random(9)+1;
  r:=9;
  {'+I2S(R)+'}

  If ParamCount>0 then begin
   FILENAME:= ParamStr(1);
   CLS(GGXSeg);
   If (UpCase(FILENAME[(Length(FILENAME)-2)])='D') then
   PlaceDPC(0,0,0,FILENAME,GGXSeg);
   If (UpCase(FILENAME[(Length(FILENAME)-2)])='P') then
   PlacePCX(FILENAME,0,GGXSeg);
   {If (UpCase(FILENAME[(Length(FILENAME)-2)])='G') then
   PlaceGGX(0,0,0,FILENAME,GGXSeg);}
  End
  Else FILENAME:='NONAME.DPC';
   LASTFILENAME:=FILENAME;



  Window[1].XPos:=0;
  Window[1].YPos:=0;
  Window[1].X1:=0;
  Window[1].Y1:=26;
  Window[1].X2:=318;
  Window[1].Y2:=198;
  Window[1].Opt1:=2;
  Window[1].Opt2:=1;
  Window[1].Opt3:=2;
  Window[1].HTitle:=' ';
  Window[1].BodyC:=BodyBarC;
  Window[1].HC:=0;
  Window[1].FillC:=White-23;
  Window[1].TextC:=White;
  Window[1].TextHC:=White;
  Window[1].Zoom:=2;
  Window[1].Title:=FileName;

  CurrentWindows:=1;
  TSize:=1;
  PlaceWindows(VirSeg);

  PlaceColorBoard(VirSeg);
  If ShowPCords then PlacePCords(VirSeg);
  If ShowTStuff then PlaceTStuff(VirSeg);
  If ShowPrompt then PlacePrompt(VirSeg);
  MouseProcess3;

  {214-144}

  MouseProcess1;
  MouseProcess2;
  MouseProcess3;
  MouseProcess1;
  FadetoBlack(50);
  Flip(VirSeg,VidSeg,OffSet);
  Fadeto(PALETTEFILENAME,25);

  If (UpCase(FILENAME[(Length(FILENAME)-2)])='P') then
  PlacePCX(FILENAME,1,GGXSeg);

  MouseProcess2;
  EnterBo('Glen''s Art Studio R2',Red);
  EnterBo('version: 4.01',Orange);
  EnterBo('ghbarratt@hotmail.com',Yellow);

  Repeat
   MouseProcess3;
   SysRC:=SysRC+1;
   If SysRC>244 then SysRC:=214;
   MouseProcess1;
   Flip(VirSeg,VidSeg,OffSet);
   Delay(50);

   MouseProcess2;
   If ShowPCords then RefreshPCords(VirSeg);
   If ShowTStuff then PlaceTStuff(VirSeg);
   If ShowPrompt then PlacePrompt(VirSeg);

   PActO:=PAct;
   PTypeO:=PType;
   PAct:=1;
   Key:='~';
   Key2:='~';
   Null:=False;

   If Keypressed then Key:=Readkey;
   If Key=Chr(0) then begin
    Null:=True;
    Key:='~';
    Key2:=ReadKey;
   End;

   If Key=chr(13) then PAct:=2;
   If Key=' ' then PAct:=3;

   If LeftPressed then PAct:=2;
   If RightPressed then PAct:=3;

   If UpCase(Key)='Z' then UNDO;

   If (PAct<>PActO)and(PAct>1){and(PType<>PTypeO)} then
   Begin
    Case PTypeO of
     3:SaveDPC('UNDO.DAT',GGXSeg);
     4:SaveDPC('UNDO.DAT',GGXSeg);
     5:SaveDPC('UNDO.DAT',GGXSeg);
     6:SaveDPC('UNDO.DAT',GGXSeg);
    End;
    For i3:=0 to 399 do Mem[P1Seg:i3]:=0;
    For i3:=0 to 399 do Mem[P2Seg:i3]:=0;
    For i3:=0 to 399 do Mem[P3Seg:i3]:=0;
    For i3:=0 to 399 do Mem[PCutSeg:i3]:=0;
    LoadPSeg(PType);
   End;

   If (PAct>1)and(PY>13)and(PY<25) then begin
    PAct:=1;
    PlaceMainStuff(VirSeg);
    PlaceWindows(VirSeg);
    PlaceColorBoard(VirSeg);
    If ShowPCords then PlacePCords(VirSeg);
    If ShowTStuff then PlaceTStuff(VirSeg);
    If ShowPrompt then PlacePrompt(VirSeg);

    If (PX>0)and(PX<41) then MenuOpt:=1;
    If (PX>40)and(PX<76) then MenuOpt:=2;
    If (PX>75)and(PX<118) then MenuOpt:=3;
    If (PX>117)and(PX<171) then MenuOpt:=4;
    If (PX>170)and(PX<226) then MenuOpt:=5;
    If (PX>225)and(PX<279) then MenuOpt:=6;
    If (PX>278)and(PX<321) then MenuOpt:=7;
   End;


   If MenuOpt<>0 then begin
    PlaceMenuOpt(Green,VirSeg);
    PAct:=1;
   End;

   If (LeftPressed)and(RightPressed) then begin
    PType:=PType+1;
    If PType>MaxPTypes then PType:=1;
    LoadPSeg(PType);
    {For i3:= 0 to 199 do For i2:= 0 to 319 do Mem[GGXOSeg:320*i3+i2]:=Mem[GGXSeg:320*i3+i2];}
   End;

   If (Key>='1')and(Key<='9') then PType:=S2I(Key);

   Case PType of
    1:Prompt:='BASIC POINTER';
    2:Prompt:='ZOOM ';
    3:Prompt:='MARKER';
    4:Prompt:='HORIZONTAL ROLLER';
    5:Prompt:='VERTICAL ROLLER';
    6:Prompt:='TEXT';
    7:Prompt:='DROPPER';
    8:Prompt:='SHAPER';
    9:Prompt:='SELECTER';
    0:Prompt:='FX/FILL';
   End;

   If (PAct=1)and(MovingWindow<>0) then begin
    PlaceMainStuff(VirSeg);
    PlaceWindows(VirSeg);
    PlaceColorBoard(VirSeg);
    If ShowPCords then PlacePCords(VirSeg);
    If ShowTStuff then PlaceTStuff(VirSeg);
    If ShowPrompt then PlacePrompt(VirSeg);
    MovingWindow:=0;
   End;


   If PAct>1 then begin
    For i:=1 to CurrentWindows do begin
     If (PType=2)and(PX>Window[i].X1)and(PX<Window[i].X2)
     and(PY>Window[i].Y1+14)and(PY<Window[i].Y2-2)then begin
      If Window[i].X2>319 then Window[i].X2:=319;
      If Window[i].Y2>ColorBoardY-1 then Window[i].Y2:=ColorBoardY-1;
      For Y:=Window[i].Y1 to Window[i].Y2 do For X:=Window[i].X1 to Window[i].X2 do Mem[VirSeg:Y*320+X]:=BackGroundC;

      If PAct=2 then Window[i].Zoom:=Window[i].Zoom+1;
      If PAct=3 then Window[i].Zoom:=Window[i].Zoom-1;

      If Window[i].Zoom<1 then Window[i].Zoom:=1;
      If Window[i].Zoom>8 then Window[i].Zoom:=8;

      Window[i].XPos:=(Round(Window[i].Zoom+(PX+(Window[i].Zoom*Window[i].XPos)-(Window[i].X1+3)-Window[i].Zoom*0.62
      -Round((Window[i].X2+Window[i].X1)/2))/Window[i].Zoom));

      Window[i].YPos:=(Round(Window[i].Zoom+(PY+(Window[i].Zoom*Window[i].YPos)-(Window[i].X1+3)-Window[i].Zoom*0.355
      -Round((Window[i].Y2+Window[i].Y1)/2))/Window[i].Zoom));


      If Window[i].Zoom<1 then Window[i].Zoom:=1;
      If Window[i].Zoom>8 then Window[i].Zoom:=8;
      If Window[i].XPos<0 then Window[i].XPos:=0;
      If Window[i].YPos<0 then Window[i].YPos:=0;
      If Window[i].XPos>GGXWidth-5 then Window[i].XPos:=GGXWidth-5;
      If Window[i].YPos>GGXLength-5 then Window[i].YPos:=GGXLength-5;
      PlaceWindow(i,VirSeg);
     End;
    End;

    For i:=1 to CurrentWindows do begin
     If (PType=3)and(Window[i].Opt1=2)and(PX>Window[i].X1)and(PX<Window[i].X2)
     and(PY>Window[i].Y1+13)and(PY<Window[i].Y2-2)then begin
      If PAct=2 then
      For i4:=0 to TSize-1 do
      For i3:=0 to TSize-1 do
      Mem[GGXSeg:320*(Round((PY+(Window[i].Zoom*Window[i].YPos)-(Window[i].Y1+14)-
      Window[i].Zoom*0.355)/Window[i].Zoom)+i4-TSize div 2)
      +(Round((PX+(Window[i].Zoom*Window[i].XPos)-(Window[i].X1+3)-Window[i].Zoom*0.62)/Window[i].Zoom)+i3-TSize div 2)]:=
      SelectC1;

      If PAct=3 then
      For i4:=0 to TSize-1 do
      For i3:=0 to TSize-1 do
      Mem[GGXSeg:320*(Round((PY+(Window[i].Zoom*Window[i].YPos)-(Window[i].Y1+14)-
      Window[i].Zoom*0.355)/Window[i].Zoom)+i4-TSize div 2)
      +(Round((PX+(Window[i].Zoom*Window[i].XPos)-(Window[i].X1+3)-
      Window[i].Zoom*0.62)/Window[i].Zoom)+i3-TSize div 2)]:=SelectC2;

      PlaceWindow(i,VirSeg);
     End;

     If (PType=4)and(Window[i].Opt1=2)and(PX>Window[i].X1)and(PX<Window[i].X2)
     and(PY>Window[i].Y1+13)and(PY<Window[i].Y2-2)then begin
      If PAct=2 then
      For i4:=0 to TSize-1 do
      Mem[GGXSeg:320*(Round((PY+(Window[i].Zoom*Window[i].YPos)-
      (Window[i].Y1+5.5)-Window[i].Zoom*0.355)/Window[i].Zoom)+i4-TSize div 2)
      +Round((PX+(Window[i].Zoom*Window[i].XPos)-(Window[i].X1+3)-
      Window[i].Zoom*0.62)/Window[i].Zoom)]:=SelectC1;
      If PAct=3 then
      For i4:=0 to TSize-1 do
      Mem[GGXSeg:320*(Round((PY+(Window[i].Zoom*Window[i].YPos)-
      (Window[i].Y1+5.5)-Window[i].Zoom*0.355)/Window[i].Zoom)+i4-TSize div 2)
      +Round((PX+(Window[i].Zoom*Window[i].XPos)-(Window[i].X1+3)-
      Window[i].Zoom*0.62)/Window[i].Zoom)]:=SelectC2;
      PlaceWindow(i,VirSeg);
     End;

     If (PType=5)and(Window[i].Opt1=2)and(PX>Window[i].X1)and(PX<Window[i].X2)
     and(PY>Window[i].Y1+13)and(PY<Window[i].Y2-2)then begin
      If PAct=2 then
      For i4:=0 to TSize-1 do
      Mem[GGXSeg:320*Round((PY+(Window[i].Zoom*Window[i].YPos)-(Window[i].Y1+15.25)-Window[i].Zoom*0.355)/Window[i].Zoom)
      +(Round((PX+(Window[i].Zoom*Window[i].XPos)-(Window[i].X1-6)-Window[i].Zoom*0.62)/Window[i].Zoom)+i4-TSize div 2)]:=
      SelectC1;
      If PAct=3 then
      For i4:=0 to TSize-1 do
      Mem[GGXSeg:320*Round((PY+(Window[i].Zoom*Window[i].YPos)-(Window[i].Y1+15.25)-Window[i].Zoom*0.355)/Window[i].Zoom)
      +(Round((PX+(Window[i].Zoom*Window[i].XPos)-(Window[i].X1-6)-Window[i].Zoom*0.62)/Window[i].Zoom)+i4-TSize div 2)]:=
      SelectC2;
      PlaceWindow(i,VirSeg);
     End;

     If (PType=6)and(Window[i].Opt1=2)and(PX>Window[i].X1)and(PX<Window[i].X2)
     and(PY>Window[i].Y1+13)and(PY<Window[i].Y2-2)then begin
     If PAct=2 then begin
       EnterOption('Enter Text',SelectC1);

 {i:=1;}

 PlaceText((Round((PX-6+(Window[i].Zoom*Window[i].XPos)-(Window[i].X1-6)-Window[i].Zoom*0.62)/Window[i].Zoom)+i4-TSize div 2),
 Round((PY+3+(Window[i].Zoom*Window[i].YPos)-(Window[i].Y1+15.25)-Window[i].Zoom*0.355)/Window[1].Zoom),
 XChangeStr,SelectC1,GGXSeg);
       PlaceWindow(i,VirSeg);
      End;
      PAct:=1;
     End;
    End;

    For i:=1 to CurrentWindows do begin
     If (PType=1)and(MovingWindow=0)and(PX>Window[i].X1)and(PX<Window[i].X2)
     and(PY>Window[i].Y1)and(PY<Window[i].Y1+12)and
     ((PX<Button[1+i].X)or(PX>Button[1+i].X+8)or(PY<Button[1+i].Y)or(PY>Button[1+i].Y+8))
     then begin
      SPX:=PX-Window[i].X1;
      SPY:=PY-Window[i].Y1;
      MovingWindow:=i;
     End;
    End;
   End;

   If (MovingWindow<>0) then begin
    i2:=MovingWindow;
    If Window[i].Y2>ColorBoardY-1 then Window[i].Y2:=ColorBoardY-1;
    If Window[i].X2>319 then Window[i].X2:=319;
    For Y:=Window[i2].Y1 to Window[i2].Y2 do For X:=Window[i2].X1 to Window[i2].X2 do Mem[VirSeg:Y*320+X]:=BackGroundC;
    If PY<14 then PY:=14;
    X:=Window[i2].X2-Window[i2].X1;
    Y:=Window[i2].Y2-Window[i2].Y1;
    Window[i2].X1:=PX-SPX;
    Window[i2].Y1:=PY-SPY;
    If Window[i2].X1<0 then Window[i2].X1:=0;
    If Window[i2].Y1<26 then Window[i2].Y1:=26;
    If Window[i2].X1+X>319 then Window[i2].X1:=319-X;
    If Window[i2].Y1+Y>ColorBoardY-1 then Window[i2].Y1:=ColorBoardY-1-Y;
    Window[i2].X2:=Window[i2].X1+X;
    Window[i2].Y2:=Window[i2].Y1+Y;
    If Window[i2].X1+X>319 then Window[i2].X2:=319;
    If Window[i2].Y1+Y>ColorBoardY-1 then Window[i2].Y2:=ColorBoardY-1;
    If Window[i2].X1<0 then Window[i2].X1:=0;
    If Window[i2].Y1<26 then Window[i2].Y1:=26;
    PXO:=PX;
    PYO:=PY;
    PX:=Window[i2].X1+SPX;
    PY:=Window[i2].Y1+SPY;
    If ShowPCords then RefreshPCords(VirSeg);
    PlaceWindow(i2,VirSeg);
   End;

   If (PX>ColorBoardX+58)and(PX<=ColorBoardX+314)
   and(PY>ColorBoardY+2)and(PY<=ColorBoardY+19) then begin
    If PAct=2 then SelectC1:=Mem[VirSeg:320*PY+PX];
    If PAct=3 then SelectC2:=Mem[VirSeg:320*PY+PX];
    RefreshSelectedColors(VirSeg);
   End;

   For i3:=1 to CurrentButtons do begin
    If ((PAct=1)and(Button[i3].BAct<>1))and
    ((PX>=Button[i3].X)and(PX<Button[i3].X+9)and(PY>=Button[i3].Y)and(PY<Button[i3].Y+9)) then begin
     Button[i3].BType:=1;
     Button[i3].BAct:=1;
     Case i3 of
      1:begin
         PlaceButton(Button[i3].X-OffSet,Button[i3].Y,Button[i3].BType,Button[i3].BAct,VidSeg);
         PlacePSeg(PX-OffSet,PY,PAct,VidSeg);
         ExitStuff;
        End;
      2:begin
         Sound(200);
         Delay(20);
         NoSound;
        End;
     End;
     PlaceButton(Button[i3].X-OffSet,Button[i3].Y,Button[i3].BType,Button[i3].BAct,VirSeg);
    End;
    If ((PAct=1)and(Button[i3].BAct<>1))or
    ((PX<Button[i3].X)or(PX>=Button[i3].X+9)or(PY<Button[i3].Y)or(PY>=Button[i3].Y+9)) then begin
     Button[i3].BAct:=1;
     If (i3<>2)or(MenuOpt=0)then PlaceButton(Button[i3].X,Button[i3].Y,Button[i3].BType,Button[i3].BAct,VirSeg);
    End;
    If PType=1 then begin
     If (PAct=2)or(PAct=3) then begin
      If (PX>=Button[i3].X)and(PX<Button[i3].X+9)and(PY>=Button[i3].Y)and(PY<Button[i3].Y+9) then begin
       Button[i3].BAct:=2;
       PlaceButton(Button[i3].X,Button[i3].Y,Button[i3].BType,Button[i3].BAct,VirSeg);
      End;
     End;
    End;
   End;




   If (PType=7)and(PAct=2) then begin
    SelectC1:=Mem[VirSeg:PX+320*PY+320];
    RefreshSelectedColors(VirSeg);
   End;
   If (PType=7)and(PAct=3) then begin
    SelectC2:=Mem[VirSeg:PX+320*PY+320];
    RefreshSelectedColors(VirSeg);
   End;
   If (LastPType=PType)and(LastPAct=2)and(PAct=1) then begin
    If PType=7 then SelectC1:=Mem[VirSeg:PX+320*PY+320];
   End;

   LastPAct:=PAct;
   LastPType:=PType;


   If (Key>Chr(47))and(Key<Chr(58)) then begin
    PType:=Ord(Key)-48;
    LoadPSeg(PType);
    {For i3:= 0 to 199 do For i2:= 0 to 319 do Mem[GGXOSeg:320*i3+i2]:=Mem[GGXSeg:320*i3+i2];}
   End;

   If Key='+' then TSize:=TSize+1;
   If Key='-' then TSize:=TSize-1;
   If TSize<1 then TSize:=1;
{   If Key='P'thenbegin}
   If Key='[' then begin
    GDIRS(MenuBarC,MenuBarHC,TextC,3);
    If St='EXIT' then begin
     St:='*.*';
     PAct:=1;
    End
    Else begin
     LoadPalette(DirStart+St);
    End;
    PlaceMainStuff(VirSeg);
    PlaceWindows(VirSeg);
    PlaceColorBoard(VirSeg);
    If ShowPCords then PlacePCords(VirSeg);
    If ShowTStuff then PlaceTStuff(VirSeg);
    If ShowPrompt then PlacePrompt(VirSeg);
   End;
   If Key=']' then begin
    GDIRS(MenuBarC,MenuBarHC,TextC,4);
    If St='EXIT' then begin
     St:='*.*';
     PAct:=1;
    End
    Else begin
     SavePalette(DirStart+St);
    End;
    PlaceMainStuff(VirSeg);
    PlaceWindows(VirSeg);
    PlaceColorBoard(VirSeg);
    If ShowPCords then PlacePCords(VirSeg);
    If ShowTStuff then PlaceTStuff(VirSeg);
    If ShowPrompt then PlacePrompt(VirSeg);
   End;

   If Key='\' then RotateColors(1);
   If Key='|' then RotateColors(-1);

   If UpCase(Key)='F' then begin
    SaveDPC('UNDO.DAT',GGXSeg);
    FlipImage;
    PlaceWindow(1,VirSeg);
   End;
   If UpCase(Key)='D' then begin
    SaveDPC('UNDO.DAT',GGXSeg);
    MirrorImage;
    PlaceWindow(1,VirSeg);
   End;
   If UpCase(Key)='S' then begin
    SaveDPC('UNDO.DAT',GGXSeg);
    RotateImage;
    PlaceMainStuff(VirSeg);
    PlaceWindows(VirSeg);
    PlaceColorBoard(VirSeg);
    If ShowPCords then PlacePCords(VirSeg);
    If ShowTStuff then PlaceTStuff(VirSeg);
    If ShowPrompt then PlacePrompt(VirSeg);
   End;

   If UpCase(Key)='I' then begin
    SaveDPC('UNDO.DAT',GGXSeg);
    InvertImageColors;
    PlaceWindows(VirSeg);
   End;

   If UpCase(Key)='A' then begin
    SaveDPC('UNDO.DAT',GGXSeg);
    ReCropSize;
    PlaceMainStuff(VirSeg);
    PlaceWindows(VirSeg);
    PlaceColorBoard(VirSeg);
    If ShowPCords then PlacePCords(VirSeg);
    If ShowTStuff then PlaceTStuff(VirSeg);
    If ShowPrompt then PlacePrompt(VirSeg);
   End;

   If Null then begin
    Null:=False;
    Case Key2 of
{     'D': SKeys;}
  Chr(59):Begin
       If EnterBo('Start a New Pic?',20) then begin
        EnterOption('Horiz Width (0-320)',20);
        GGXWidth:=XChangeInt;
        EnterOption('Vert Length (0-200)',20);
        GGXLength:=XChangeInt;
        Window[1].Title:='UNSAVED';
        CLS(GGXSeg);
        For i2:=0 to 199 do
        For i:=0 to 319 do
        Mem[GGXSeg:320*i2+i]:=SelectC2;
       End;
       PlaceMainStuff(VirSeg);
       PlaceWindows(VirSeg);
       PlaceColorBoard(VirSeg);
       If ShowPCords then PlacePCords(VirSeg);
       If ShowTStuff then PlaceTStuff(VirSeg);
       If ShowPrompt then PlacePrompt(VirSeg);
      End;
     Chr(61):Begin
          {Fadeto(PALETTEFILENAME,20);}
          GDIRS(MenuBarC,MenuBarHC,TextC,2);

          If St='EXIT' then begin
           St:='*.*';
           If FILENAME[Length(FILENAME)-2]='D' then
           SaveDPC(FILENAME,GGXSeg)
           Else If FILENAME[Length(FILENAME)-2]='G' then
           SaveGGX(FILENAME,GGXSeg)
           Else PlacePCX(FILENAME,1,GGXSeg);
           PAct:=1;
          End
          Else begin
           {PlacePCX(FILENAME,1,GGXSeg);}
           LASTFILENAME:=FILENAME;
           FILENAME:=DirStart+St;
           Window[1].Title:=St;
           If UpCase(FILENAME[Length(FILENAME)-2])='D' then
           SaveDPC(FILENAME,GGXSeg);
           If UpCase(FILENAME[Length(FILENAME)-2])='G' then
           SaveGGX(FILENAME,GGXSeg);
          End;
          PlaceMainStuff(VirSeg);
          PlaceWindows(VirSeg);
          PlaceColorBoard(VirSeg);
          If ShowPCords then PlacePCords(VirSeg);
          If ShowTStuff then PlaceTStuff(VirSeg);
          If ShowPrompt then PlacePrompt(VirSeg);
         End;

     Chr(60):Begin
          Fadeto(PALETTEFILENAME,20);
          GDIRS(MenuBarC,MenuBarHC,TextC,1);
          If St='EXIT' then begin
           St:='*.*';
           PlacePCX(FILENAME,1,GGXSeg);
           PAct:=1;
          End
          Else begin
           LASTFILENAME:=FILENAME;
           CLS(GGXSeg);
           Window[1].XPos:=0;
           Window[1].YPos:=0;
           FILENAME:=DirStart+St;
           Window[1].Title:=St;
           If FILENAME[Length(FILENAME)-2]='D' then
           PlaceDPC(0,0,0,FILENAME,GGXSeg);
           If FILENAME[Length(FILENAME)-2]='P' then
           PlacePCX(FILENAME,1,GGXSeg);
          End;
          PlaceMainStuff(VirSeg);
          PlaceWindows(VirSeg);
          PlaceColorBoard(VirSeg);
          If ShowPCords then PlacePCords(VirSeg);
          If ShowTStuff then PlaceTStuff(VirSeg);
          If ShowPrompt then PlacePrompt(VirSeg);
         End;
     '?':Begin
          SelectC1:= SelectC1-1;
          RefreshSelectedColors(VirSeg);
         End;
     '@':Begin
          SelectC1:= SelectC1+1;
          RefreshSelectedColors(VirSeg);
         End;
     'A':Begin
          SelectC2:= SelectC2-1;
          RefreshSelectedColors(VirSeg);
         End;
     'B':Begin
          SelectC2:=SelectC2+1;
          RefreshSelectedColors(VirSeg);
         End;
    End;
   End;


   If Key=Chr(27) then begin
    XChangeStr:='Y';
    If EnterBo('Really Exit?',Red) then ExitStuff;
   End;
  Until Key='';
 END.
